// DlgCoordTrans2D.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgCoordTrans2D.h"
#include "DlgCalPara2D.h"
#include "GeoGlobal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCoordTrans2D dialog


CDlgCoordTrans2D::CDlgCoordTrans2D(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCoordTrans2D::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCoordTrans2D)
	m_dX0 = 0.0;
	m_dY0 = 0.0;
	m_PathOpen = _T("");
	m_PathSave = _T("");
	m_Scale = 0.0;
	m_Silta = 0.0;
	//}}AFX_DATA_INIT
}


void CDlgCoordTrans2D::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCoordTrans2D)
	DDX_Text(pDX, IDC_EDIT_dX0, m_dX0);
	DDX_Text(pDX, IDC_EDIT_dY0, m_dY0);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	DDX_Text(pDX, IDC_EDIT_PathSave, m_PathSave);
	DDX_Text(pDX, IDC_EDIT_Scale, m_Scale);
	DDX_Text(pDX, IDC_EDIT_Silta, m_Silta);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCoordTrans2D, CDialog)
	//{{AFX_MSG_MAP(CDlgCoordTrans2D)
	ON_BN_CLICKED(IDC_Btn_ImportPara, OnBtnImportPara)
	ON_BN_CLICKED(IDC_Btn_CalPara, OnBtnCalPara)
	ON_BN_CLICKED(IDC_BUTTON_Open, OnBUTTONOpen)
	ON_BN_CLICKED(IDC_BUTTON_Save, OnBUTTONSave)
	ON_BN_CLICKED(IDC_Btn_Trans, OnBtnTrans)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCoordTrans2D message handlers

void CDlgCoordTrans2D::OnBtnImportPara() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_PathPara,a,m_stringRead;
	double dX0,dY0,XuanZhuan,SuoFang;
	CStdioFile m_FilePara;
	CFileDialog MyFileDlg(TRUE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathPara=MyFileDlg.GetPathName();
	if(!m_FilePara.Open(m_PathPara,CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    m_FilePara.ReadString(m_stringRead);
	if (m_stringRead!="Shift:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&dX0) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if (a!="dx0:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&dY0) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="dy0:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	if (m_stringRead!="Rotation:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
	m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&XuanZhuan) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="d:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	if (m_stringRead!="Scale:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&SuoFang) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="d:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
	a="";
	m_dX0=dX0;
	m_dY0=dY0;
	m_Silta=XuanZhuan;
	m_Scale=SuoFang;

	UpdateData(FALSE);
	
}

void CDlgCoordTrans2D::OnBtnCalPara() 
{
	// TODO: Add your control notification handler code here
	CDlgCalPara2D dlg;
	if(dlg.DoModal() != IDOK) return;
	m_dX0=dlg.m_dX0;
	m_dY0=dlg.m_dY0;
	m_Silta=dlg.m_Silta;
	m_Scale=dlg.m_Scale;
	UpdateData(FALSE);
	
}

void CDlgCoordTrans2D::OnBUTTONOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,NULL,NULL,0,"(*.*)|*.*||k");

	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}

void CDlgCoordTrans2D::OnBUTTONSave() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathSave=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}


void CDlgCoordTrans2D::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CDlgCoordTrans2D::OnBtnTrans() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	TransParam2D  sTransParam;
	CCoordSysTrans m_coordsystrans;
	sTransParam.Deltax=m_dX0;
	sTransParam.Deltay=m_dY0;
	sTransParam.Scale=m_Scale;
	sTransParam.Silta=m_Silta;

	CStdioFile    m_sfile,m_sfileW;
	CString m_stringRead,a;
	if(!m_sfile.Open(m_PathOpen,CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_sfileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	Coordxyh      m_xyh,m_xyh1;

	sTransParam.Silta=sTransParam.Silta*PI/(3600*180);
	CString		str1;
    while(m_sfile.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf",a,&m_xyh.x,&m_xyh.y) < 3) continue;

		m_coordsystrans.CoordTrans2D(m_xyh,&m_xyh1,sTransParam);

 		m_sfileW.WriteString(a);
		m_sfileW.WriteString(" ");
		str1.Format("%13.5lf",m_xyh1.x);
		m_sfileW.WriteString(str1);
		m_sfileW.WriteString(" ");
		str1.Format("%13.5lf",m_xyh1.y);
		m_sfileW.WriteString(str1);
		m_sfileW.WriteString("\n");
	}
	m_sfile.Close();
	m_sfileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
	
}
