// DlgCoordTrans3D.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgCoordTrans3D.h"
#include "DlgCalPara3D.h"
#include "GeoGlobal.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCoordTrans3D dialog


CDlgCoordTrans3D::CDlgCoordTrans3D(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCoordTrans3D::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCoordTrans3D)
	m_dX0 = 0.0;
	m_dY0 = 0.0;
	m_dZ0 = 0.0;
	m_PathOpen = _T("");
	m_PathSave = _T("");
	m_Siltax = 0.0;
	m_Siltay = 0.0;
	m_Siltaz = 0.0;
	m_Scale = 0.0;
	//}}AFX_DATA_INIT
}


void CDlgCoordTrans3D::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCoordTrans3D)
	DDX_Text(pDX, IDC_EDIT_dX0, m_dX0);
	DDX_Text(pDX, IDC_EDIT_dY0, m_dY0);
	DDX_Text(pDX, IDC_EDIT_dZ0, m_dZ0);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	DDX_Text(pDX, IDC_EDIT_PathSave, m_PathSave);
	DDX_Text(pDX, IDC_EDIT_Siltax, m_Siltax);
	DDX_Text(pDX, IDC_EDIT_Siltay, m_Siltay);
	DDX_Text(pDX, IDC_EDIT_Siltaz, m_Siltaz);
	DDX_Text(pDX, IDC_EDIT_Scale, m_Scale);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCoordTrans3D, CDialog)
	//{{AFX_MSG_MAP(CDlgCoordTrans3D)
	ON_BN_CLICKED(IDC_Btn_ImportPara, OnBtnImportPara)
	ON_BN_CLICKED(IDC_Btn_CalPara, OnBtnCalPara)
	ON_BN_CLICKED(IDC_BUTTON_Open, OnBUTTONOpen)
	ON_BN_CLICKED(IDC_BUTTON_Save, OnBUTTONSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCoordTrans3D message handlers

void CDlgCoordTrans3D::OnBtnImportPara() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CString m_PathPara,a,m_stringRead;
	double dX0,dY0,dZ0,Siltax,Siltay,Siltaz,Scale;
	CStdioFile m_FilePara;
	CFileDialog MyFileDlg(TRUE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathPara=MyFileDlg.GetPathName();
	if(!m_FilePara.Open(m_PathPara,CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
    m_FilePara.ReadString(m_stringRead);
	if (m_stringRead!="Shift:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&dX0) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="dX0:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&dY0) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="dY0:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&dZ0) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="dZ0:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	if (m_stringRead!="Rotation:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
	m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&Siltax) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="x:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&Siltay) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="y:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&Siltaz) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="z:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	if (m_stringRead!="Scale:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
    m_FilePara.ReadString(m_stringRead);
	m_stringRead.TrimLeft();
	m_stringRead.TrimRight();

	if(m_stringRead.GetLength() < 3 )
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}

	if(sscanf(m_stringRead,"%s %lf",a,&Scale) < 2)
	{
		AfxMessageBox("ѡȷʽļ");
		return;	
	}
	if (a!="d:")
	{
		AfxMessageBox("ѡȷʽļ");
		return;
	}
	a="";
	m_dX0=dX0;
	m_dY0=dY0;
	m_dZ0=dZ0;
	m_Siltax=Siltax;
	m_Siltay=Siltay;
	m_Siltaz=Siltaz;
	m_Scale=Scale;
	UpdateData(FALSE);
}

void CDlgCoordTrans3D::OnBtnCalPara() 
{
	// TODO: Add your control notification handler code here
	CDlgCalPara3D dlg;
	if(dlg.DoModal() != IDOK) return;
	m_dX0=dlg.m_dX0;
	m_dY0=dlg.m_dY0;
	m_dZ0=dlg.m_dZ0;
	m_Siltax=dlg.m_Siltax;
	m_Siltay=dlg.m_Siltay;
	m_Siltaz=dlg.m_Siltaz;
	m_Scale=dlg.m_Scale;
	UpdateData(FALSE);
	
}

void CDlgCoordTrans3D::OnBUTTONOpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,NULL,NULL,0,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}

void CDlgCoordTrans3D::OnBUTTONSave() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathSave=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}

void CDlgCoordTrans3D::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);

	TransParam3D  sTransParam;
	CCoordSysTrans m_coordsystrans;
	sTransParam.Deltax=m_dX0;
	sTransParam.Deltay=m_dY0;
	sTransParam.Deltaz=m_dZ0;
	sTransParam.Scale=m_Scale;
	sTransParam.Siltax=m_Siltax;
	sTransParam.Siltay=m_Siltay;
	sTransParam.Siltaz=m_Siltaz;

	CStdioFile    m_sfile,m_sfileW;
	CString m_stringRead,a;
	if(!m_sfile.Open(m_PathOpen,CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	if(!m_sfileW.Open(m_PathSave,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	CoordXYZ      m_XYZ,m_XYZ1;

	sTransParam.Siltax=sTransParam.Siltax*PI/(3600*180);
	sTransParam.Siltay=sTransParam.Siltay*PI/(3600*180);
	sTransParam.Siltaz=sTransParam.Siltaz*PI/(3600*180);
	CString		str1;
    while(m_sfile.ReadString(m_stringRead))
	{

		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 7 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf %lf",a,&m_XYZ.X,&m_XYZ.Y,&m_XYZ.Z) < 4) continue;

		m_coordsystrans.CoordTrans3D(m_XYZ,&m_XYZ1,sTransParam);

 
		m_sfileW.WriteString(a);
		m_sfileW.WriteString(" ");
		str1.Format("%13.5lf",m_XYZ1.X);
		m_sfileW.WriteString(str1);
		m_sfileW.WriteString(" ");
		str1.Format("%13.5lf",m_XYZ1.Y);
		m_sfileW.WriteString(str1);
		m_sfileW.WriteString(" ");
		str1.Format("%13.5lf",m_XYZ1.Z);
		m_sfileW.WriteString(str1);
		m_sfileW.WriteString("\n");
	}
	m_sfile.Close();
	m_sfileW.Close();
	
	ShellExecute(NULL,"Open",m_PathSave,NULL,NULL,SW_SHOWNORMAL);
}
