/////////////////////////////////////////////////////////////////////////////
// ռάת
#include "stdafx.h"
#include "GeoGlobal.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////////
//άڴ
long double ** TwoArrayAlloc(int r,int c)
{
	long double  *x, **y;
	int n;

	x=(long double *)calloc(r*c,sizeof(long double));
	if(x==NULL)
    {
		AfxMessageBox("Failure in memory applying!");  
		exit(0);
    }

	y=(long double **)calloc(r,sizeof(long double *));
	for(n=0;n<=r-1;++n)
		y[n]=&x[c*n];
	return(y);		//???????
}

void TwoArrayFree(long double **x)
{
	free(x[0]);
	free(x);
}

//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//Ƕȵ໥ת
int SignOfDouble(double d)	//жһ˫
{
	int i;
	if (d>0)
		i=1;
	else if(d<0)
		i=-1;
	else
		i=0;
	return  i;
}

double Degree2Rad(const double para)	//ת
{
	double Radian;
	Radian=(para*PI)/180.0;
	return Radian;
}

double Rad2Degree(const double para)	//ת
{
	double Degree;
	Degree=para*180.0/PI;
	return Degree;
}

double Rad2DMS(const double s_rad)//ת.ַ
{
	double rad;
	rad=s_rad;
	int i=SignOfDouble(rad);
	rad=fabs(rad);
	if(rad>2*PI)
		rad=rad-floor(rad/(2*PI))*2*PI;
	rad *= 180.0/PI;
	double degree=fabs(rad);
	double temp1=floor(degree + 0.1e-10);
	double temp2=(degree-temp1)*60.0;
	double temp3=floor(temp2 + 0.1e-10);
	double temp4=(temp2-temp3)*60.0;
	degree=temp1+temp3/100.0+temp4/10000.0;
	double dms=i*degree;
	return dms;
}

double DMS2Rad(const double s_dms)//.ַת
{
	double dms;
	dms=s_dms;
	int i=SignOfDouble(dms);
	dms=fabs(dms);
	double temp=floor(dms + 0.1e-10);// 0.001 ֹ
	double temp1=floor((dms-temp)*100.0 + 0.1e-10);// 0.001 ֹ
	double temp2=((dms-temp)*100-temp1)*100;
	dms=temp+temp1/60.0+temp2/3600.0;
	double rad=i*dms;
	rad*=PI/180.0;
	return rad;
}

double DMS2Degree(double dms)//".."ʽĽǶתΪ""ʽ
{
	int i=SignOfDouble(dms);
	dms=fabs(dms);
	double temp=floor(dms + 0.1e-10);
	double temp1=floor((dms-temp)*100.0 + 0.1e-10);
	double temp2=((dms-temp)*100-temp1)*100;
	dms=temp+temp1/60.0+temp2/3600.0;
	double degree=i*dms;
	return degree;
}

double Degree2DMS(double degree)//""ʽĽǶתΪ".."ʽ
{
	int i=SignOfDouble(degree);
	degree=fabs(degree);
	double temp1=floor(degree + 0.1e-10);
	double temp2=(degree-temp1)*60.0;
	double temp3=floor(temp2 + 0.1e-10);
	double temp4=(temp2-temp3)*60.0;
	degree=temp1+temp3/100.0+temp4/10000.0;
	double dms=i*degree;
	return dms;
}

//ԽǶȵĴСƣĬ0-2PI
double AngleLimit(double Angle,double AngleMin=0,double AngleMax=2*PI,double Cycle=2*PI)
{
	while(Angle < AngleMin) Angle+=Cycle;
	while(Angle >= AngleMax) Angle-=Cycle;

	return Angle;
}
double AngleTransfer(double Angle,int TypeIn,int TypeOut)	//ĺҪĽǶȵλʵֵλת
{
	//0:rad; 1:d.mmss ; 2:degree;
	double AngleNeed;
	if (TypeIn==0&&TypeOut==0)
	{
		AngleNeed=Angle;
	}
	else if (TypeIn==0&&TypeOut==1)
	{
		AngleNeed=Rad2DMS(Angle);
	}
	else if (TypeIn==0&&TypeOut==2)
	{
		AngleNeed=Rad2Degree(Angle);
	}
	else if (TypeIn==1&&TypeOut==0)
	{
		AngleNeed=DMS2Rad(Angle);
	}
	else if (TypeIn==1&&TypeOut==1)
	{
		AngleNeed=Angle;
	}
	else if (TypeIn==1&&TypeOut==2)
	{
		AngleNeed=DMS2Degree(Angle);
	}
	else if (TypeIn==2&&TypeOut==0)
	{
		AngleNeed=Degree2Rad(Angle);
	}
	else if (TypeIn==2&&TypeOut==1)
	{
		AngleNeed=Degree2DMS(Angle);
	}
	else if (TypeIn==2&&TypeOut==2)
	{
		AngleNeed=Angle;
	}
	return AngleNeed;
}

void C3DpointExchange::AngleTransfer(int TypeIn,int TypeOut)//ĺҪĽǶȵλʵֵλת
{
	m_BLH.B=::AngleTransfer(m_BLH.B,TypeIn,TypeOut);
	m_BLH.L=::AngleTransfer(m_BLH.L,TypeIn,TypeOut);
}
//////////////////////////////////////////////////////////////////////////

//ݽǶ͵ȡֵõӦַ
CString GetCsAngleType(int i)
{
		CString str;
		switch(i)
		{
			case 0:
				str.Format("");
				break;
			case 1:
				str.Format(".ַ");
				break;
			case 2:
				str.Format("");
				break;
			default:
				//no operation
				break;
		}
		return str;
	
}
//////////////////////////////////////////////////////////////////////////
//ת
BOOL C3DpointExchange::BLH2XYZ()//BLHXYZ
{
	//transfer to rad from degree,dms,etc.
	AngleTransfer(m_AngleTypeIn,0);
	//calculate the XYZ
	double N,A,E2 ;
	m_Sphere.GetSpherePara(&A,NULL,&E2);
	N = A/sqrt(1.0-E2*sin(m_BLH.B)*sin(m_BLH.B));
	m_XYZ.X=(N+m_BLH.H)*cos(m_BLH.B)*cos(m_BLH.L);
	m_XYZ.Y=(N+m_BLH.H)*cos(m_BLH.B)*sin(m_BLH.L);
	m_XYZ.Z=(N*(1.0-E2)+m_BLH.H)*sin(m_BLH.B);
	return TRUE;
}
BOOL C3DpointExchange::BLH2XYZ(const double B,const double L,const double H,double *X,double *Y,double *Z,int AngleTypeIn,CSphere *s_Sphere)
{
	//transfer to rad from degree,dms,etc.
	double Btmp,Ltmp;
	Btmp=::AngleTransfer(B,AngleTypeIn,0);
	Ltmp=::AngleTransfer(L,AngleTypeIn,0);
	//calculate the XYZ
	double N,A,E2 ;
	if(s_Sphere != NULL)
	{
		s_Sphere->GetSpherePara(&A,NULL,&E2);
	}
	else
	{
		CSphere sphere;
		sphere.GetSpherePara(&A,NULL,&E2);
	}
	N = A/sqrt(1.0-E2*sin(Btmp)*sin(Btmp));
	if(X !=NULL)
		*X=(N+H)*cos(Btmp)*cos(Ltmp);
	if(Y !=NULL)
		*Y=(N+H)*cos(Btmp)*sin(Ltmp);
	if(Z !=NULL)
		*Z=(N*(1.0-E2)+H)*sin(Btmp);
	return TRUE;
}

BOOL C3DpointExchange::XYZ2BLH()//XYZBLH
{
	//calculate the BLH
	double B0,R;
	double N,A,E2 ;
	m_Sphere.GetSpherePara(&A,NULL,&E2);
	R=sqrt(m_XYZ.X*m_XYZ.X+m_XYZ.Y*m_XYZ.Y);
	B0=atan2(m_XYZ.Z,R);
	while(1)
	{
		N=A/sqrt(1.0-E2*sin(B0)*sin(B0));
		m_BLH.B=atan2(m_XYZ.Z+N*E2*sin(B0),R);
		if(fabs(m_BLH.B- B0 )<1.0e-12 ) 
			break;
		B0 =m_BLH.B ;
	}
	m_BLH.L=atan2(m_XYZ.Y,m_XYZ.X);
	m_BLH.H=R/cos(m_BLH.B)-N;
	//transfer  rad to degree,dms,etc.
	AngleTransfer(0,m_AngleTypeOut);
	return TRUE;
}
BOOL C3DpointExchange::XYZ2BLH(const double X,const double Y,const double Z,double *B,double *L,double *H,int AngleTypeOut,CSphere *s_Sphere)
{
	//calculate the BLH
	double B0,R;
	double N,A,E2 ;
	if(s_Sphere!=NULL)
	{
		s_Sphere->GetSpherePara(&A,NULL,&E2);
	}
	else
	{
		CSphere sphere;
		sphere.GetSpherePara(&A,NULL,&E2);
	}
	R=sqrt(X*X+Y*Y);
	B0=atan2(Z,R);
	while(1)
	{
		N=A/sqrt(1.0-E2*sin(B0)*sin(B0));
		*B=atan2(Z+N*E2*sin(B0),R);
		if(fabs(*B- B0 )<1.0e-12 ) 
			break;
		B0 =*B ;
	}
	*L=atan2(Y,X);
	if(H != NULL)
		*H=R/cos(*B)-N;
	//transfer rad to degree,dms,etc.
	*B=::AngleTransfer(*B,0,AngleTypeOut);
	*L=::AngleTransfer(*L,0,AngleTypeOut);
	return TRUE;
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//˹ͶӰ
//BLHxyh
BOOL C3DpointExchange::BLH2xyh(double midL,double originY,double originX,double midB,double mapH)//BLHxyh
{
	//transfer to rad from degree,dms,etc.
	midL=::AngleTransfer(midL,2,0);
	midB=::AngleTransfer(midB,2,0);
	AngleTransfer(m_AngleTypeIn,0);
	if (((m_BLH.L-midL)<(-(3/180)*PI))||((m_BLH.L-midL)>((3/180)*PI)))
	{
		AfxMessageBox("ͶӰ㾭3ȣܻϴ");
	}
	//calculate the xyh
	double a1,a2,a3,a4;
	double aa,bb,cc,dd;
	double C,x2,x4,x6,x8,x10;
	double r0,r1,r2,r3;
	double X0,X00,Tb,Y2,M0,M2;
	double N,A,E2 ;
	m_Sphere.GetSpherePara(&A,NULL,&E2);
	
	C=A/sqrt(1.0-E2);
	x2=E2;
	x4=x2*x2;
	x6=x2*x4;
	x8=x2*x6;
	x10=x2*x8;
    aa=1.0+3.0*x2/4.0+45.0*x4/64.0+175.0*x6/256.0;
	aa=aa+11025.0*x8/16384.0 +43659.0*x10/65536.0;
	bb=3.0* x2/4.0+15.0*x4/16.0+525.0*x6/512.0;
	bb=bb+2205.0*x8/2048.0+72765.0*x10/65536.0;
	cc=15.0*x4/64.0+105.0*x6/256.0;
	cc=cc+2205.0*x8/4096.0+10395.0*x10/16384.0;
	dd=35.0*x6/512.0+315.0*x8/2048.0+31185.0*x10/13072.0;
	a1=aa*A*(1.0-E2);
	a2=-bb*A*(1.0-E2)/2.0;
	a3=cc*A*(1.0-E2)/4.0;
	a4=-dd*A*(1.0-E2 )/6.0;
	r0=a1 ;
	r1=-2.0*a2-4.0*a3-6.0*a4;
	r2=8.0*a3+32.0*a4;
	r3=-32.0*a4 ;
    Tb=tan(m_BLH.B);
    Y2=x2/(1.0-x2)*cos(m_BLH.B)*cos(m_BLH.B);
    N=C/sqrt(1.0+Y2);
	
	X0=r0*m_BLH.B-cos(m_BLH.B)*sin(m_BLH.B)*(r1+sin(m_BLH.B)*sin(m_BLH.B)*(r2+sin(m_BLH.B)*sin(m_BLH.B)*r3));
	X00=r0*midB-cos(midB)*sin(midB)*(r1+sin(midB)*sin(midB)*(r2+sin(midB)*sin(midB)*r3));
	
	M0=cos(m_BLH.B)*(m_BLH.L-midL);
	M2=M0*M0;
	
	m_xyh.x = (X0-X00) + M2*N*Tb/2.0+M2*M2*N*Tb/24.0*(5.0-Tb*Tb+9.0*Y2+4.0*Y2*Y2)
		+M2*M2*M2*N*Tb/720.0*(61.0+(Tb*Tb-58.0)*Tb*Tb);	
	m_xyh.y = N*M0+N*M0*M2/6.0*(1.0+Y2-Tb*Tb)+N*M0*M2*M2/120.0*(5.0+(Tb*Tb-18.0)
		*Tb*Tb-(58.0*Tb*Tb-14.0)*Y2);
	m_xyh.x=m_xyh.x+originX;
	m_xyh.y=m_xyh.y+originY;
	m_xyh.h=m_BLH.H;
	return TRUE;
}

BOOL C3DpointExchange::BLH2xyh(CoordBLH s_BLH,Coordxyh *s_xyh,int AngleTypeIn,double midL,double originY,CSphere *s_Sphere,int ProType,double originX,double midB,double mapH)
{
	//transfer to rad from degree,dms,etc.
	midL=::AngleTransfer(midL,2,0);
	midB=::AngleTransfer(midB,2,0);
	s_BLH.B=::AngleTransfer(s_BLH.B,AngleTypeIn,0);
	s_BLH.L=::AngleTransfer(s_BLH.L,AngleTypeIn,0);

	//calculate the xyh
	double a1,a2,a3,a4;
	double aa,bb,cc,dd;
	double C,x2,x4,x6,x8,x10;
	double r0,r1,r2,r3;
	double X0,X00,Tb,Y2,M0,M2;
	double N,A,E2 ;
	if(s_Sphere != NULL)
	{
		s_Sphere->GetSpherePara(&A,NULL,&E2);
	}
	else
	{
		CSphere sphere;
		sphere.GetSpherePara(&A,NULL,&E2);
	}
	
	C=A/sqrt(1.0-E2);
	
	x2=E2;
	x4=x2*x2;
	x6=x2*x4;
	x8=x2*x6;
	x10=x2*x8;
	
    aa=1.0+3.0*x2/4.0+45.0*x4/64.0+175.0*x6/256.0;
	aa=aa+11025.0*x8/16384.0 +43659.0*x10/65536.0;
	
	bb=3.0* x2/4.0+15.0*x4/16.0+525.0*x6/512.0;
	bb=bb+2205.0*x8/2048.0+72765.0*x10/65536.0;
	
	cc=15.0*x4/64.0+105.0*x6/256.0;
	cc=cc+2205.0*x8/4096.0+10395.0*x10/16384.0;
	
	dd=35.0*x6/512.0+315.0*x8/2048.0+31185.0*x10/13072.0;
	
	a1=aa*A*(1.0-E2);
	a2=-bb*A*(1.0-E2)/2.0;
	a3=cc*A*(1.0-E2)/4.0;
	a4=-dd*A*(1.0-E2 )/6.0;
	
	r0=a1 ;
	r1=-2.0*a2-4.0*a3-6.0*a4;
	r2=8.0*a3+32.0*a4;
	r3=-32.0*a4 ;
	
    Tb=tan(s_BLH.B);
    Y2=x2/(1.0-x2)*cos(s_BLH.B)*cos(s_BLH.B);
    N=C/sqrt(1.0+Y2);
	
	X0=r0*s_BLH.B-cos(s_BLH.B)*sin(s_BLH.B)*(r1+sin(s_BLH.B)*sin(s_BLH.B)*(r2+sin(s_BLH.B)*sin(s_BLH.B)*r3));
	
	X00=r0*midB-cos(midB)*sin(midB)*(r1+sin(midB)*sin(midB)*(r2+sin(midB)*sin(midB)*r3));
	
	M0=cos(s_BLH.B)*(s_BLH.L-midL);
	M2=M0*M0;
	
	s_xyh->x = (X0-X00) + M2*N*Tb/2.0+M2*M2*N*Tb/24.0*(5.0-Tb*Tb+9.0*Y2+4.0*Y2*Y2)
		+M2*M2*M2*N*Tb/720.0*(61.0+(Tb*Tb-58.0)*Tb*Tb);	
	
	s_xyh->y = N*M0+N*M0*M2/6.0*(1.0+Y2-Tb*Tb)+N*M0*M2*M2/120.0*(5.0+(Tb*Tb-18.0)
		*Tb*Tb-(58.0*Tb*Tb-14.0)*Y2);
	
	if (ProType==0)//˹ͶӰ
	{
		s_xyh->x=s_xyh->x+originX;
		s_xyh->y=s_xyh->y+originY;
	}
	else if (ProType==1)//īͶӰ
	{
		s_xyh->x=0.9996*s_xyh->x+originX;
		s_xyh->y=0.9996*s_xyh->y+originY;
	}
	
	s_xyh->h=s_BLH.H;
	return TRUE;
}

//xyhBLH
BOOL C3DpointExchange::xyh2BLH(double midL,double originY,double originX,double midB,double mapH)//xyhBLH
{
	midL=::AngleTransfer(midL,2,0);
	midB=::AngleTransfer(midB,2,0);

	int i ;
	double a1,a2,a3,a4;
	double aa,bb,cc,dd;
	double C,x2,x4,x6,x8,x10;
	double K1,K2,K3;
	
	double r0,r1,r2,r3;
	
	double b11[5],r11[5],d11[5]; 
	double Nf,Bf,Tf,Y2,Vf2,Mf,y,y2,y4,X00;
	double A,E2 ;
	m_Sphere.GetSpherePara(&A,NULL,&E2);
	
	C=A/sqrt(1.0-E2);
	
	x2=E2;
	x4=x2*x2;
	x6=x2*x4;
	x8=x2*x6;
	x10=x2*x8;
	
    aa=1.0+3.0*x2/4.0+45.0*x4/64.0+175.0*x6/256.0;
	aa=aa+11025.0*x8/16384.0 +43659.0*x10/65536.0;
	
	bb=3.0* x2/4.0+15.0*x4/16.0+525.0*x6/512.0;
	bb=bb+2205.0*x8/2048.0+72765.0*x10/65536.0;
	
	cc=15.0*x4/64.0+105.0*x6/256.0;
	cc=cc+2205.0*x8/4096.0+10395.0*x10/16384.0;
	
	dd=35.0*x6/512.0+315.0*x8/2048.0+31185.0*x10/13072.0;
	
	a1=aa*A*(1.0-E2);
	a2=-bb*A*(1.0-E2)/2.0;
	a3=cc*A*(1.0-E2)/4.0;
	a4=-dd*A*(1.0-E2)/6.0;
	
	r0=a1 ;
	r1=-2.0*a2-4.0*a3-6.0*a4;
	r2=8.0*a3+32.0*a4;
	r3=-32.0*a4 ;
	
	b11[0]=-a2/a1;
	r11[0]=-a3/a1;	
	d11[0]=-a4/a1;
	
	for(i=0;i<4;i++)
	{
		b11[i+1]=b11[0]+b11[0]*r11[i]-2.0*r11[0]*b11[i]-3.0*b11[0]*b11[i]*b11[i]/2.0;
		r11[i+1]=r11[0]+b11[0]*b11[i];
		d11[i+1]=d11[0]+b11[0]*r11[i]+2.0*r11[0]*b11[i]+b11[0]*b11[i]*b11[i]/2.0;
	}
	
	K1=2.0*b11[4]+4.0*r11[4]+6.0*d11[4];
	K2=-8.0*r11[4]-32.0*d11[4];
	K3=32.0*d11[4];
	
	X00=r0*midB-cos(midB)*sin(midB)*(r1+sin(midB)*sin(midB)*(r2+sin(midB)*sin(midB)*r3));
	
	Bf=( m_xyh.x - originX + X00 )/a1;
	Bf=Bf+cos(Bf)*sin(Bf)*(K1+sin(Bf)*sin(Bf)*(K2+sin(Bf)*sin(Bf)*K3));
	
	Tf=tan(Bf);
	
	Y2=x2/(1.0-x2)*cos(Bf)*cos(Bf);
	
	Vf2=1.0+x2/(1.0-x2)*cos(Bf)*cos(Bf);
	
	Nf=sqrt(Vf2)/C;
	
	Mf=Vf2*Nf;
	
	y=(m_xyh.y-originY)*Nf;
	
	y2=y*y;
	y4=y2*y2;
	
	
	m_BLH.B = Bf-Vf2*Tf*y2/2.0 + Vf2*Tf*y4*(5.0+3.0*Tf*Tf+Y2-9.0*Y2*Tf*Tf)/24.0
		- Vf2*Tf*y2*y4*(61.0+(90.0+45.0*Tf*Tf)*Tf*Tf)/720.0;
	
	m_BLH.L=  y/cos(Bf)-y*y2/6.0/cos(Bf)*(1.0+Y2+2.0*Tf*Tf)
		+y*y4/120.0/cos(Bf)*(5+(6+8*Tf*Tf)*Y2+(28+24*Tf*Tf)*Tf*Tf);
	
	m_BLH.L=m_BLH.L+midL;
	
	m_BLH.H=m_xyh.h;
	
	//transfer  rad to degree,dms,etc.
	AngleTransfer(0,m_AngleTypeOut);
	return TRUE;
}
BOOL C3DpointExchange::xyh2BLH(Coordxyh s_xyh,CoordBLH *s_BLH,int AngleTypeOut,double midL,double originY,CSphere *s_Sphere,int ProType,double originX,double midB,double mapH)
{
	midL=::AngleTransfer(midL,2,0);
	midB=::AngleTransfer(midB,2,0);
	if (ProType==1)//īͶӰ
	{
		s_xyh.x=(s_xyh.x-originX)/0.99960+originX;
		s_xyh.y=(s_xyh.y-originY)/0.99960+originY;
	}
	int i ;
	double a1,a2,a3,a4;
	double aa,bb,cc,dd;
	double C,x2,x4,x6,x8,x10;
	double K1,K2,K3;
	
	double r0,r1,r2,r3;
	
	double b11[6],r11[6],d11[6]; 
	double Nf,Bf,Tf,Y2,Vf2,Mf,y,y2,y4,X00;
	
	double A,E2 ;
	if(s_Sphere != NULL)
	{
		s_Sphere->GetSpherePara(&A,NULL,&E2);
	}
	else
	{
		CSphere sphere;
		sphere.GetSpherePara(&A,NULL,&E2);
	}

	C=A/sqrt(1.0-E2);
	
	x2=E2;
	x4=x2*x2;
	x6=x2*x4;
	x8=x2*x6;
	x10=x2*x8;
	
    aa=1.0+3.0*x2/4.0+45.0*x4/64.0+175.0*x6/256.0;
	aa=aa+11025.0*x8/16384.0 +43659.0*x10/65536.0;
	
	bb=3.0* x2/4.0+15.0*x4/16.0+525.0*x6/512.0;
	bb=bb+2205.0*x8/2048.0+72765.0*x10/65536.0;
	
	cc=15.0*x4/64.0+105.0*x6/256.0;
	cc=cc+2205.0*x8/4096.0+10395.0*x10/16384.0;
	
	dd=35.0*x6/512.0+315.0*x8/2048.0+31185.0*x10/13072.0;
	
	a1=aa*A*(1.0-E2);
	a2=-bb* A*(1.0-E2)/2.0;
	a3=cc*A*(1.0-E2)/4.0;
	a4=-dd*A*(1.0-E2 )/6.0;
	
	r0=a1 ;
	r1=-2.0*a2-4.0*a3-6.0*a4;
	r2=8.0*a3+32.0*a4;
	r3=-32.0*a4 ;
	
	b11[0]=-a2/a1;
	r11[0]=-a3/a1;	
	d11[0]=-a4/a1;
	
	for(i=0;i<5;i++)
	{
		b11[i+1]=b11[0]+b11[0]*r11[i]-2.0*r11[0]*b11[i]-3.0*b11[0]*b11[i]*b11[i]/2.0;
		r11[i+1]=r11[0]+b11[0]*b11[i];
		d11[i+1]=d11[0]+b11[0]*r11[i]+2.0*r11[0]*b11[i]+b11[0]*b11[i]*b11[i]/2.0;
	}
	
	K1=2.0*b11[5]+4.0*r11[5]+6.0*d11[5];
	K2=-8.0*r11[5]-32.0*d11[5];
	K3=32.0*d11[5];
	
	X00=r0*midB-cos(midB)*sin(midB)*(r1+sin(midB)*sin(midB)*(r2+sin(midB)*sin(midB)*r3));
	
	Bf=( s_xyh.x - originX + X00 )/a1;
	Bf=Bf+cos(Bf)*sin(Bf)*(K1+sin(Bf)*sin(Bf)*(K2+sin(Bf)*sin(Bf)*K3));
	
	Tf=tan(Bf);
	
	Y2=x2/(1.0-x2)*cos(Bf)*cos(Bf);
	
	Vf2=1.0+x2/(1.0-x2)*cos(Bf)*cos(Bf);
	
	Nf=sqrt(Vf2)/C;
	
	Mf=Vf2*Nf;
	
	y=(s_xyh.y-originY)*Nf;
	
	y2=y*y;
	y4=y2*y2;
	
	
	s_BLH->B = Bf-Vf2*Tf*y2/2.0 + Vf2*Tf*y4*(5.0+3.0*Tf*Tf+Y2-9.0*Y2*Tf*Tf)/24.0
		- Vf2*Tf*y2*y4*(61.0+(90.0+45.0*Tf*Tf)*Tf*Tf)/720.0;
	
	s_BLH->L=  y/cos(Bf)-y*y2/6.0/cos(Bf)*(1.0+Y2+2.0*Tf*Tf)
		+y*y4/120.0/cos(Bf)*(5+(6+8*Tf*Tf)*Y2+(28+24*Tf*Tf)*Tf*Tf);
	
	s_BLH->L=s_BLH->L+midL;
	
	s_BLH->H=s_xyh.h;
	
	//transfer  rad to degree,dms,etc.
	s_BLH->B=::AngleTransfer(s_BLH->B,0,AngleTypeOut);
	s_BLH->L=::AngleTransfer(s_BLH->L,0,AngleTypeOut);
	return TRUE;	
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//˹ͶӰ㺯
BOOL C3DpointExchange::GaussChangeZone(const double midL1,const double midL2,double originY,double originX,double midB,double mapH)
{
	if (m_AngleTypeIn!=m_AngleTypeOut)
	{
		AfxMessageBox("лʹĽǶȵλһ£");
		return FALSE;
	}
	xyh2BLH(midL1,originY);
	BLH2xyh(midL2,originY);
	return TRUE;
}
BOOL C3DpointExchange::GaussChangeZone(const double x1,const double y1,const double h1,double *x2,double *y2,double *h2,const double midL1,const double midL2,double originY,CSphere *s_Sphere,int ProType,double originX,double midB,double mapH)
{
	Coordxyh m_xyh,m_xyh2;
	CoordBLH m_BLH;
	m_xyh.x=x1;
	m_xyh.y=y1;
	m_xyh.h=h1;
	if (((midL1-midL2)<(-6))||((midL1-midL2)>6))
	{
		AfxMessageBox("6ȣܻϴ");
	}

	xyh2BLH(m_xyh,&m_BLH,0,midL1,originY,s_Sphere,ProType);
	BLH2xyh(m_BLH,&m_xyh2,0,midL2,originY,s_Sphere,ProType);
	*x2=m_xyh2.x;
	*y2=m_xyh2.y;
	*h2=m_xyh2.h;
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//Ӻ
long double GeodeticSolution::ACOS(long double t)
{
	long double t2;
	if((1.0-t*t) < 1.0e-10) 
	{ 
		t2=0.0;
	}
	else 
	{ 
		t2=PI/2.0-atan(t/sqrt(1-t*t)); 
	}
	return t2;
}

long double GeodeticSolution::SGN(long double t)
{
	long double sgn=0.0;
	if (t > 0.0) { sgn = 1.0; }
	if (t == 0.0) { sgn = 0.0; }
	if (t < 0.0) { sgn =-1.0; }
	return sgn;
}

long double GeodeticSolution::K3(long double un, long double F)
{
	long double v,k3;
	v = F * sin(un) * sin(un) / 4;
	k3 = v * (1 + F + F * F - v * (12 + 27 * F - 50 * v) / 4);
	return k3;
}

void GeodeticSolution::K1K2(long double e, long double un, long double *k1, long double *k2)
{
	long double T; 
	T = e * sin(un) * sin(un) / 4;
	*k1 = 1 + T * (1 - T / 4 * (3 - T * (5 - 11 * T)));
	*k2 = T * (1 - T * (2 - T * (37 - 94 * T) / 8));
}

long double GeodeticSolution::DG(long double gm, long double G, long double k2)
{
	long double p,p1,p2,p3,y1,y2,y3,y4,y5,dg;
	p = 2 * gm;
	p1 = 2 * G;
	p2 = k2 / 4;
	p3 = k2 / 6;
	y1 = sin(G);
	y2 = cos(gm);
	y3 = cos(G);
	y4 = cos(p);
	y5 = cos(p1);
	dg = k2 * y1 * (y2 + p2 * (y3 * y4 + p3 * y2 * (1 + 2 * y5) * (1 - 2 * y4)));
	return dg;
}
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//
BOOL GeodeticSolution::GeoBL2SA(double B1,double L1,double B2,double L2,double *S,double *A,int AngleTypeIn,int AngleTypeOut,CSphere *s_Sphere)
{
	if(B1 == B2 && L1 == L2) //ͬһΪ
	{
		*S=0;
		*A=0;
		return TRUE;
	}
	//transfer to rad from degree,dms,etc.
	B1=AngleTransfer(B1,AngleTypeIn,0);
	L1=AngleTransfer(L1,AngleTypeIn,0);
	B2=AngleTransfer(B2,AngleTypeIn,0);
	L2=AngleTransfer(L2,AngleTypeIn,0);
	
	long double DL,u1,u2,B21,qb=0.0,dw=0.0;
	long double t,w,qw=0.0,g1,g2,G,c1,c2,F,qg=0.0,un=0,gm,k3,dd;
	long double e,k1=0.0,k2=0.0,dg=0.0;
	long double A1,qa=0.0,a2,q2;

	double Alfa,E2,B ;
	if(s_Sphere != NULL)
	{
		s_Sphere->GetSpherePara(NULL,&Alfa,&E2,&B);
	}
	else //Ĭϵ
	{
		CSphere tmpsphere;//ĬϵĹ캯ȡֵ
		tmpsphere.GetSpherePara(NULL,&Alfa,&E2,&B);
	}

	DL=L2-L1;
	if( DL<0.0 ) { DL = DL+2*PI; }
	u1=atan((1.0-Alfa)*tan(B1));
	u2=atan((1.0-Alfa)*tan(B2));
	B21=B2-B1;
	qb=SGN(B21);
	int i0=1;
	while(1)
	{
		t = dw;
        w = L2 - L1 + dw;
        qw = SGN(w);
		g1=cos(u2) * sin(w);
		g2=cos(u1) * sin(u2) - sin(u1) * cos(u2) * cos(w);
        G = sqrt(g1 * g1  + g2 * g2);
        G = G / (sin(u1) * sin(u2) + cos(u1) * cos(u2) * cos(w));
        qg = SGN(G);
        G = atan(G) + (1 - qg) * PI / 2 ;
		c1=cos(u1) * cos(u2) * sin(w) / sin(G);
		c2=cos(G) - 2 * sin(u1) * sin(u2) / sin(un) / sin(un);
		un=ACOS(c1);
		gm=ACOS(c2);
		F=Alfa;
		k3=K3(un,F);
        dw = (1 - k3) * F * cos(un) * (G + k3 * sin(G) * (cos(gm) + k3 * cos(G) * cos(2 * gm)));
        dd = fabs(dw - t);
        i0 = i0 + 1;
		if(dd < 1.0e-12)
			break;		
	}
	e=E2;
	K1K2( e, un, &k1, &k2);
	dg=DG(gm, G, k2);
	*S=k1*(B)*(G-dg);
	
	A1 = cos(u2) * sin(w) / (cos(u1) * sin(u2) - sin(u1) * cos(u2) * cos(w));
	qa = SGN(A1);
	A1 = atan(A1) + (2 - qw - qa) * PI / 2; 
	a2 = cos(u1) * sin(w) / (cos(u1) * sin(u2) * cos(w) - sin(u1) * cos(u2));
	q2 = SGN(a2);
	a2 = atan(a2) + (2 - qw - q2) * PI / 2;      
	long double i,j;                          //ڼ˶
	i = cos(u1) * sin(A1);
	j = cos(u2) * sin(a2);
	
	if (DL < PI && A1 > PI)    
	{
		a2 = a2 - PI; 
		A1 = A1 - PI;
	}
	if (DL > PI && A1 < PI)    
	{
		a2 = a2 + PI; 
		A1 = A1 + PI;
	}
	if (DL = 0.0 && B1 > 0.0 && B2 < 0.0 && A1 < 0.05)   
	{
		a2 = a2 + PI; 
		A1 = A1 + PI; 
	}
	if (DL = 0.0 && B1 < 0.0 && B2 > 0.0 && A1 > (PI - 0.05))   
	{
		a2 = a2 - PI; 
		A1 = A1 - PI;
	}
	if (L1==L2&&B1<B2)
	{
		A1=0;
	}
	
	//transfer  rad to degree,dms,etc.
	*A=AngleTransfer(A1,0,AngleTypeOut);
	
	return TRUE;
}

//ⷴ
// -180~180,γ -90~90
BOOL GeodeticSolution::GeoSA2BL(double B1,double L1,double S,double A,double *B2,double *L2,int AngleTypeIn,int AngleTypeOut,CSphere *s_Sphere)
{
	if(S == 0) //Ϊ,ͬһ
	{
		*B2=AngleTransfer(B1,AngleTypeIn,AngleTypeOut);
		*L2=AngleTransfer(L1,AngleTypeIn,AngleTypeOut);
		return TRUE;
	}
	//transfer to rad from degree,dms,etc.

	B1=AngleTransfer(B1,AngleTypeIn,0);
	L1=AngleTransfer(L1,AngleTypeIn,0);
	A=AngleTransfer(A,AngleTypeIn,0);

	A=AngleLimit(A);
	
	long double F,e,u1,un,q1,k1=0.0,k2=0.0,k3,b,G1,G0=0.0,qg,dg=0.0;
	long double t,G,gm,dd;
	long double G2,h1,h2,h3,u2,w,dw;
	long double da1,a2,q2,LL2;
	
	double Alfa,E2,B ;
	if(s_Sphere != NULL)
	{
		s_Sphere->GetSpherePara(NULL,&Alfa,&E2,&B);
	}
	else //Ĭϵ
	{
		CSphere tmpsphere;//ĬϵĹ캯ȡֵ
		tmpsphere.GetSpherePara(NULL,&Alfa,&E2,&B);
	}

	F = Alfa;
	e = E2;
	u1 = atan((1 - F) * tan(B1));
	un = ACOS(cos(u1) * sin(A));
	q1 = SGN(sin(A));
	K1K2( e, un, &k1, &k2);
	k3=K3(un,F);
	
	b = B;
	G1 = atan(tan(u1) / cos(A));
	G0 = S / k1 / b;
	qg = SGN(tan(G0));
	int i0 = 1;
	while(1)
	{
		t = dg;
		G = G0 + dg;
		gm = 2 * G1 + G;
		dg=DG(gm, G, k2);
		dd = fabs(dg - t);
		i0 = i0 + 1;
		if(dd < 1.0e-12)
			break;
	}
	G2 = G1 + G;
	u2 = sin(u1) * cos(G) + cos(u1) * sin(G) * cos(A);
	h1 = cos(un) * cos(un);
	h2 = sin(u1) * sin(G);
	h3 = cos(u1) * cos(G) * cos(A);
	u2 = u2 / sqrt(h1 + (h2 - h3) * (h2 - h3));
	*B2 = atan(u2 / (1 - F));
	
	w=sin(G)*sin(A)/(cos(u1)*cos(G)-sin(u1)*sin(G)*cos(A));
	w = atan(w) + (1 - qg) * PI / 2 * q1;
	dw = (1 - k3) * F * cos(un) * (G + k3 * sin(G) * (cos(gm) + k3 * cos(G) * cos(2 * gm)));
	LL2 = L1 + w - dw;
	dd = LL2 - L1;
	if (dd < 0.0)   { dd = dd + 2 * PI; }
	if (A > 0.0  && A < PI && dd > PI)   { LL2 = LL2 + PI; }
	if (A > PI && dd < PI)   { LL2 = LL2 - PI;}
	if (LL2 > 2 * PI)   { LL2 = LL2 - 2 * PI; }
	if (LL2 < 0.0)   { LL2 = LL2 + 2 * PI; }
	dd = LL2 - L1;
	da1 = A - PI;
	if (da1 < 0.01 && B1 > 0.0 && *B2 < 0.0 && dd > (PI - 0.01))  { LL2 = LL2 - PI; }
	if (da1 < 0.01 && B1 < 0.0 && *B2 > 0.0 && dd > (PI - 0.01))  { LL2 = LL2; }
	//*L2 = LL2;
	
	a2 = cos(un) / (cos(u1) * cos(G) * cos(A) - sin(u1) * sin(G));
	q2 = SGN(a2);
	a2 = atan(a2) + (2 - q1 - q2) * PI / 2;
	long double i,j;                         //ڼ
	i = cos(u1) * sin(A);
	j = cos(atan(u2)) * sin(a2);
	
	if(LL2 > PI) LL2 -= 2*PI;//ת-180~+180
	//transfer  rad to degree,dms,etc.
	*B2=AngleTransfer(*B2,0,AngleTypeOut);
	*L2=AngleTransfer(LL2,0,AngleTypeOut);
	
	return TRUE;
}



int C3DpointExchange::xyh2BLHWithL0(double dN, double dE, double dH, int nFlag,double dL0dms,CoordBLH *blh)
{
	double dx=dN;
	double dy=dE;
    //dx9997964.943021
    //dx>9997964.943021ӦB>90
	//dH򳤰᳤෴
	double m_da,m_df;
	m_Sphere.GetSpherePara(&m_da,&m_df);
	m_df=1.0/m_df;

	if(dy<0||dx>9997964.943021||dH<m_da*(-1.0))
		return false;
	//dx,dyͬʱΪ0
	if((dx==0)&&(dy==0))
		return false;
	
	//׼
	//˹ͶӰƽֵ
	double a=m_da;
	double f=m_df;
	double x,y;
	if(nFlag==1)
	{
		x=dx/0.9996;
		y=(dy-500000.0)/0.9996;
	}
	else if(nFlag==0)
	{
		x=dx;
		y=dy-500000.0;
	}

	double e=2.0/f-1.0/f/f;
	double e12= e/(1.0-e);
	double e1= 1.0-e;
    
	//߻⹫ʽ׵γBf
	//幫ʽġôϵ任컪ͳž48ҳ
	//              ϵĽ컪ͳ38ҳ
	double Bf=0,b;
	double A=1.0+3.0/4.0*e+45.0/64.0*pow(e,2)+175.0/256.0*pow(e,3)+11025.0/16384.0*pow(e,4)+43659.0/65536.0*pow(e,5)+693693.0/1048576.0*pow(e,6)+2760615.0/4194304.0*pow(e,7);
	double can1=A*a*e1;
	double xishu1=can1;
	b=x/xishu1;//Ϊĳʼֵ
	for(;;)
	{ 
		
		double dsin=sin(b);
		double dcos=cos(b);
		//Ȧ
		//double A=1.0+3.0/4.0*e+45.0/64.0*pow(e,2)+175.0/256.0*pow(e,3)+11025.0/16384.0*pow(e,4)+43659.0/65536.0*pow(e,5)+693693.0/1048576.0*pow(e,6)+2760615.0/4194304.0*pow(e,7);
		double B=3.0/4.0*e+45.0/64.0*pow(e,2)+175.0/256.0*pow(e,3)+11025.0/16384.0*pow(e,4)+43659.0/65536.0*pow(e,5)+693693.0/1048576.0*pow(e,6)+2760615.0/4194304.0*pow(e,7);
		double C=15.0/32.0*pow(e,2)+175.0/384.0*pow(e,3)+3675.0/8192.0*pow(e,4)+14553.0/32768.0*pow(e,5)+231231.0/524288.0*pow(e,6)+920205.0/2097152.0*pow(e,7);
		double D=35.0/96.0*pow(e,3)+735.0/2048.0*pow(e,4)+14553.0/40960.0*pow(e,5)+231231.0/655360.0*pow(e,6)+184041.0/524288.0*pow(e,7);
		double E=315.0/1024.0*pow(e,4)+6237.0/20480.0*pow(e,5)+99099.0/327680.0*pow(e,6)+552123.0/1835008.0*pow(e,7);
		double F=693.0/2560.0*pow(e,5)+11011.0/40960.0*pow(e,6)+61347.0/229376.0*pow(e,7);
		//double can1=A*a*e1;
		double can2=-B*a*e1;
		double can3=-C*a*e1;
		double can4=-D*a*e1;
		double can5=-E*a*e1;
		double can6=-F*a*e1;
		double a0=can2+can3*pow(dsin,2)+can4*pow(dsin,4)+can5*pow(dsin,6)+can6*pow(dsin,8);
		double xishu2=a0*dsin*dcos;
		b=(x-xishu2)/xishu1;
		if(fabs(Bf-b)<1.0e-30) break;
		Bf=b;
	}
	
    //˹ͶӰ任
	//幫ʽġƲѧԪ⣬59ҳ
	double dsin=sin(Bf);
	double dcos=cos(Bf);
    double N=a/sqrt(1.0-e*pow(dsin,2));
    double z=y/(N*dcos);
	//double dcos2=pow(dcos,2);
	double b2=(1.0+e12*dcos*dcos)*dsin*dcos/2.0;
	double b4=(3.0+(2.0-9.0*e12)*dcos*dcos+10.0*e12*dcos*dcos*dcos*dcos)/12.0;
	double b6=(45.0-16.0*dcos*dcos*dcos*dcos)/360.0;
	double b3=(2.0-dcos*dcos+e12*dcos*dcos*dcos*dcos)/6.0;
	double b5=0.2-(1.0/6.0-(1.0+8.0*e12)*dcos*dcos/120.0+1.0*e12*dcos*dcos*dcos*dcos/60.0)*dcos*dcos;
	double B=Bf-(1-(b4-b6*z*z)*z*z)*z*z*b2;
	double l=(1-(b3-b5*z*z)*z*z)*z;
	l=l+DMS2Rad(dL0dms);
	B=Rad2DMS(B);//Set B
	l=Rad2DMS(l);
	
	blh->B=B;
	blh->L=l;
	blh->H=dH;//Set H
	return true;

}

BOOL C3DpointExchange::Geoxy2SA(double x1,double y1,double x2,double y2,double *S,double *A,int AngleTypeOut,int AngleTypeIn)
{
	double dx=0,dy=0,alfa=0;
	dx=x2-x1;
	dy=y2-y1;
	if (dx==0&&dy==0)
	{
		alfa=0.0;
	}
	else if (dx==0&&dy>0)
	{
		alfa=PI/2;
	}
	else if (dx==0&&dy<0)
	{
		alfa=PI+PI/2;
	}
	else if (dy==0&&dx>0)
	{
		alfa=0.0;
	}
	else if (dy==0&&dx<0)
	{
		alfa=PI;
	}
	else if(dx>0 && dy>0) 
	{
		alfa=atan(dy/dx);
	}
    else if(dx<0 && dy>0)
	{
		alfa=PI-atan(dy/fabs(dx));
	}
	else if(dx<0 && dy<0) 
	{
		alfa=PI+atan(dy/dx);
	}
    else if(dx>0 && dy<0)
	{
		alfa=2*PI-atan(fabs(dy)/dx);
	}
	*A=::AngleTransfer(alfa,0,AngleTypeOut);
	*S=sqrt(dx*dx+dy*dy);
	return true;
	
}

BOOL C3DpointExchange::GeoSA2xy(double x1,double y1,double S,double A,double *x2,double *y2,int AngleTypeIn,int AngleTypeOut)
{
	double dx=0,dy=0,alfa=0;
	alfa=::AngleTransfer(A,AngleTypeIn,0);
	alfa=AngleLimit(alfa);
	if (S<0)
	{
		AfxMessageBox("벻Ϊֵȷϣ");
		return false;
	}
	else if (S==0)
	{
		dx=0;
		dy=0;
	}
	else if (S>0)
	{
		dx=S*cos(alfa);
		dy=S*sin(alfa);
	}
	*x2=x1+dx;
	*y2=y1+dy;
	return true;
}

long double ** CCoordSysTrans::TwoArrayAlloc(int r,int c)
{
	long double  *x, **y;
	int n;

	x=(long double *)calloc(r*c,sizeof(long double));
	if(x==NULL)
    {
		AfxMessageBox("Failure in memory applying!");  
		exit(0);
    }

	y=(long double **)calloc(r,sizeof(long double *));
	for(n=0;n<=r-1;++n)
		y[n]=&x[c*n];
	return(y);		//???????
}

void CCoordSysTrans::TwoArrayFree(long double **x)
{
	free(x[0]);
	free(x);
}


void CCoordSysTrans::FormErrEquMatrix3D(int i,CoordXYZ xyz_s,long double *Matrix)
{
	switch(i)
	{
	case 0:
		Matrix[0]=1.0;
		Matrix[1]=0.0;
		Matrix[2]=0.0;
		Matrix[3]=xyz_s.X;
		Matrix[4]=0.0;
		Matrix[5]=-xyz_s.Z;
		Matrix[6]=xyz_s.Y;
		break;
	case 1:
		Matrix[0]=0.0;
		Matrix[1]=1.0;
		Matrix[2]=0.0;
		Matrix[3]=xyz_s.Y;
		Matrix[4]=xyz_s.Z;
		Matrix[5]=0;
		Matrix[6]=-xyz_s.X;
		break;
	case 2:
		Matrix[0]=0.0;
		Matrix[1]=0.0;
		Matrix[2]=1.0;
		Matrix[3]=xyz_s.Z;
		Matrix[4]=-xyz_s.Y;
		Matrix[5]=xyz_s.X;
		Matrix[6]=0;
		break;
	default:  
		return;
	}
}

void CCoordSysTrans::FormErrEquMatrix3D_myself(int i, CoordXYZ xyz_s, long double *Matrix)
{
	switch(i)
	{
	case 0:
		Matrix[0]=1.0;
		Matrix[1]=0.0;
		Matrix[2]=0.0;
		Matrix[3]=0.0;
		Matrix[4]=-xyz_s.Z;
		Matrix[5]=xyz_s.Y;
		Matrix[6]=xyz_s.X;
		break;
	case 1:
		Matrix[0]=0.0;
		Matrix[1]=1.0;
		Matrix[2]=0.0;
		Matrix[3]=xyz_s.Z;
		Matrix[4]=0.0;
		Matrix[5]=-xyz_s.X;
		Matrix[6]=xyz_s.Y;
		break;
	case 2:
		Matrix[0]=0.0;
		Matrix[1]=0.0;
		Matrix[2]=1.0;
		Matrix[3]=-xyz_s.Y;
		Matrix[4]=xyz_s.X;
		Matrix[5]=0.0;
		Matrix[6]=xyz_s.Z;
		break;
	default:  
		return;
	}
}

/*
ܣ ϵͳµĹάת
*/
void CCoordSysTrans::CacuTransParam3D(int ptN, CoordXYZ *Dxy, CoordXYZ *Sxy,TransParam3D *sTransParam3D)
{
	CoordXYZ    *S_xy;
	CoordXYZ    *D_xy;

	S_xy=(CoordXYZ*)calloc(ptN,sizeof(CoordXYZ));
	D_xy=(CoordXYZ*)calloc(ptN,sizeof(CoordXYZ));

	double      sxy[3];
	double      dxy[3];
	for (int i=0;i<ptN;i++)
	{
		S_xy[i].X=Sxy[i].X;
		D_xy[i].X=Dxy[i].X;
		S_xy[i].Y=Sxy[i].Y;
		D_xy[i].Y=Dxy[i].Y;
		S_xy[i].Z=Sxy[i].Z;
		D_xy[i].Z=Dxy[i].Z;
	}
	if(ptN>2)
	{

		long double         **ldStatusMatrixA;
		long double         *ldXMatrix;	
		long double     	*ldFMatrix;
		long double			*ldFeMatrix;
		long double			*ldFEMatrix;
		long double			**ldNbbMatrix;
		long double			**ldQxMatrix;
		long double			**ldPxMatrix;
   			
		ldFMatrix   =(long double*)calloc(3,sizeof(long double));
		ldFeMatrix  =(long double*)calloc(7,sizeof(long double));
		ldFEMatrix  =(long double*)calloc(7,sizeof(long double));

		ldXMatrix   =(long double*)calloc(7,sizeof(long double));

		ldStatusMatrixA=TwoArrayAlloc(3,7);
		ldNbbMatrix    =TwoArrayAlloc(7,7);
		ldPxMatrix     =TwoArrayAlloc(7,7);
		ldQxMatrix     =TwoArrayAlloc(7,7);


    


		long double *ldTempVx;	
		ldTempVx    =(long double*)calloc(7,sizeof(long double));

		for(int j=0;j<3;j++)
			*(ldFMatrix+j)=0.0;

		for(int m=0;m<7;m++)
		{
			*(ldFeMatrix+m)=0.0;
			*(ldFEMatrix+m)=0.0;
			   ldXMatrix[m]=0.0;
				ldTempVx[m]=0.0;
			for(int n=0;n<7;n++)
			{
				ldNbbMatrix[m][n]=0.0;
				ldPxMatrix[m][n]=0.0;
				ldQxMatrix[m][n]=0.0;
			}
		}
	
		for(int i=0;i<ptN;i++)
		{
			dxy[0]=D_xy[i].X;
			dxy[1]=D_xy[i].Y;
			dxy[2]=D_xy[i].Z;

			sxy[0]=S_xy[i].X;
			sxy[1]=S_xy[i].Y;
			sxy[2]=S_xy[i].Z;
			

			for(j=0;j<3;j++)
			{
				FormErrEquMatrix3D(j,S_xy[i],ldStatusMatrixA[j]);

				ldFMatrix[j]=dxy[j]-sxy[j];
			}
			m_matrix_adjust.FormNormMatrix(ldStatusMatrixA,3,7,ldNbbMatrix);
			m_matrix_adjust.FormFeMatrix(ldStatusMatrixA,3,7,ldFMatrix,ldFeMatrix);

			for(int m=0;m<7;m++)		
				for(int n=0;n<7;n++)
					ldPxMatrix[m][n]=ldPxMatrix[m][n]+ldNbbMatrix[m][n];

			for(m=0;m<7;m++)		//form the BtPL in normal equation
				ldFEMatrix[m]=ldFEMatrix[m]+ldFeMatrix[m];

			for(m=0;m<7;m++)
				for(int n=0;n<7;n++)
					ldNbbMatrix[m][n]=0;

			for(j=0;j<3;j++)
				ldFMatrix[j]=ldFeMatrix[j]=0;

		}				
		if(!m_matrix_adjust.MatrixInv(*ldPxMatrix,7))
		{
			AfxMessageBox("Failure in Normal Equation solving!");
			return;
		}
		m_matrix_adjust.MatrixMulti(*ldPxMatrix,ldFEMatrix,ldTempVx,7,7,7,1);
		for(m=0;m<7;m++)
		{
			ldXMatrix[m]=ldXMatrix[m]+ldTempVx[m];
			switch(m)
			{
			case 0:
				sTransParam3D->Deltax=ldXMatrix[m];//ƽƲ
				break;
			case 1:
				sTransParam3D->Deltay=ldXMatrix[m];
				break;
			case 2:
				sTransParam3D->Deltaz=ldXMatrix[m];
				break;
			case 3://ű
				sTransParam3D->Scale=ldXMatrix[m];
				break;
			case 4://xת
				sTransParam3D->Siltax=ldXMatrix[m]/(ldXMatrix[3]+1);
				break;
			case 5://yת
				sTransParam3D->Siltay=ldXMatrix[m]/(ldXMatrix[3]+1);
				break;
			case 6://zת
				sTransParam3D->Siltaz=ldXMatrix[m]/(ldXMatrix[3]+1);
				break;
			default:  
				return;
			}
		}

		free(ldXMatrix);
		free(ldFMatrix);
		free(ldFeMatrix);
		free(ldFEMatrix);

		TwoArrayFree(ldStatusMatrixA);
		TwoArrayFree(ldNbbMatrix);
		TwoArrayFree(ldQxMatrix);
		TwoArrayFree(ldPxMatrix);

	}
	else
	{
		AfxMessageBox("");
	}

	free(S_xy);
	free(D_xy);
}  

void CCoordSysTrans::CacuTransParam3D_myself(int ptN, CoordXYZ *D_XYZ, CoordXYZ *S_XYZ, TransParam3D *sTransParam)
{

		CoordXYZ    *S_xyz;
		CoordXYZ    *D_xyz;

		S_xyz=(CoordXYZ*)calloc(ptN,sizeof(CoordXYZ));
		D_xyz=(CoordXYZ*)calloc(ptN,sizeof(CoordXYZ));

		double      sxyz[3];
		double      dxyz[3];

		S_xyz=S_XYZ;
		D_xyz=D_XYZ;
		for (int i=0;i<ptN;i++)
		{
			S_xyz[i].X=S_XYZ[i].X;
			D_xyz[i].X=D_XYZ[i].X;
			S_xyz[i].Y=S_XYZ[i].Y;
			D_xyz[i].Y=D_XYZ[i].Y;
			S_xyz[i].Z=S_XYZ[i].Z;
			D_xyz[i].Z=D_XYZ[i].Z;
		}

		long double         **ldStatusMatrixA;
		long double         *ldXMatrix;	
		long double     	*ldFMatrix;
		long double			*ldFeMatrix;
		long double			*ldFEMatrix;
		long double			**ldNbbMatrix;
		long double			**ldQxMatrix;
		long double			**ldPxMatrix;
    
		ldFMatrix   =(long double*)calloc(3,sizeof(long double));
		ldFeMatrix  =(long double*)calloc(7,sizeof(long double));
		ldFEMatrix  =(long double*)calloc(7,sizeof(long double));

		ldXMatrix=(long double*)calloc(7,sizeof(long double));

		ldStatusMatrixA=TwoArrayAlloc(3,7);
		ldNbbMatrix    =TwoArrayAlloc(7,7);
		ldPxMatrix     =TwoArrayAlloc(7,7);
		ldQxMatrix     =TwoArrayAlloc(7,7);

		long double *ldTempVx;	
		ldTempVx    =(long double*)calloc(7,sizeof(long double));

		for(int j=0;j<3;j++)
			*(ldFMatrix+j)=0.0;

		for(int m=0;m<7;m++)
		{
			*(ldFeMatrix+m)=0.0;
			*(ldFEMatrix+m)=0.0;
			   ldXMatrix[m]=0.0;
				ldTempVx[m]=0.0;
			for(int n=0;n<7;n++)
			{
				ldNbbMatrix[m][n]=0.0;
				ldPxMatrix[m][n]=0.0;
				ldQxMatrix[m][n]=0.0;
			}
		}
	
		for(i=0;i<ptN;i++)
		{
			dxyz[0]=D_xyz[i].X;
			dxyz[1]=D_xyz[i].Y;
			dxyz[2]=D_xyz[i].Z;

			sxyz[0]=S_xyz[i].X;
			sxyz[1]=S_xyz[i].Y;
			sxyz[2]=S_xyz[i].Z;
			

			for(j=0;j<3;j++)
			{

				FormErrEquMatrix3D_myself(j,S_xyz[i],ldStatusMatrixA[j]);

				ldFMatrix[j]=dxyz[j]-sxyz[j];

			}
			m_matrix_adjust.FormNormMatrix(ldStatusMatrixA,3,7,ldNbbMatrix);
			m_matrix_adjust.FormFeMatrix(ldStatusMatrixA,3,7,ldFMatrix,ldFeMatrix);

			
			for(int m=0;m<7;m++)		
				for(int n=0;n<7;n++)
					ldPxMatrix[m][n]=ldPxMatrix[m][n]+ldNbbMatrix[m][n];



			for(m=0;m<7;m++)	
				ldFEMatrix[m]=ldFEMatrix[m]+ldFeMatrix[m];



			for(m=0;m<7;m++)
				for(int n=0;n<7;n++)
					ldNbbMatrix[m][n]=0;

			for(j=0;j<3;j++)
				ldFMatrix[j]=0;

			for (m=0;m<7;m++)
			{
				ldFeMatrix[m]=0;
			}

		}
		if(!m_matrix_adjust.MatrixInv(*ldPxMatrix,7))//ȷ
		{
	   
			AfxMessageBox("Failure in Normal Equation solving");
			return;
		}
		m_matrix_adjust.MatrixProduct(ldPxMatrix,7,7,ldFEMatrix,ldTempVx);
		for(m=0;m<7;m++)
		{
			ldXMatrix[m]=ldXMatrix[m]+ldTempVx[m];
			switch(m)
			{
			case 0:
				sTransParam->Deltax=ldXMatrix[m];//ƽƲ
				break;
			case 1:
				sTransParam->Deltay=ldXMatrix[m];
				break;
			case 2:
				sTransParam->Deltaz=ldXMatrix[m];
				break;
			case 3://
				sTransParam->Siltax=ldXMatrix[m];
				break;
			case 4://
				sTransParam->Siltay=ldXMatrix[m];
				break;
			case 5://
				sTransParam->Siltaz=ldXMatrix[m];
				break;
			case 6://
				sTransParam->Scale=ldXMatrix[m];
				break;
			default:  
				return;
			}
		}

		free(ldXMatrix);
		free(ldFMatrix);
		free(ldFeMatrix);
		free(ldFEMatrix);

		TwoArrayFree(ldStatusMatrixA);
		TwoArrayFree(ldNbbMatrix);
		TwoArrayFree(ldQxMatrix);
		TwoArrayFree(ldPxMatrix);


		free(S_xyz);
		free(D_xyz);

}
void CCoordSysTrans::CoordTrans3D(CoordXYZ m_XYZ,CoordXYZ *m_XYZ1,TransParam3D  sTransParam)
{	
 	m_XYZ1->X=m_XYZ.X+sTransParam.Siltaz*m_XYZ.Y-sTransParam.Siltay*m_XYZ.Z+sTransParam.Deltax+sTransParam.Scale*m_XYZ.X;
	m_XYZ1->Y=-sTransParam.Siltaz*m_XYZ.X+m_XYZ.Y+sTransParam.Siltax*m_XYZ.Z+sTransParam.Deltay+sTransParam.Scale*m_XYZ.Y;
	m_XYZ1->Z=sTransParam.Siltay*m_XYZ.X-sTransParam.Siltax*m_XYZ.Y+m_XYZ.Z+sTransParam.Deltaz+sTransParam.Scale*m_XYZ.Z;
}

/*
ܣÿһάת̣֪ʱ
*/
void CCoordSysTrans::FormErrEquMatrix2D(int i,Coordxyh xy_s,long double *Matrix)
{
	switch(i)
	{
	case 0:
		Matrix[0]=1.0;
		Matrix[1]=0.0;
		Matrix[2]=xy_s.x;
		Matrix[3]=-xy_s.y;
		break;
	case 1:
		Matrix[0]=0.0;
		Matrix[1]=1.0;
		Matrix[2]=xy_s.y;
		Matrix[3]=xy_s.x;
		break;
	default:  
		return;
	}

}
//ܣ ϵͳµĹάת
void CCoordSysTrans::CacuTransParam2D(int ptN, Coordxyh *Dxy, Coordxyh *Sxy,TransParam2D *sTransParam) 
{

	Coordxyh    *S_xy;
	Coordxyh    *D_xy;

	S_xy=(Coordxyh*)calloc(ptN,sizeof(Coordxyh));
	D_xy=(Coordxyh*)calloc(ptN,sizeof(Coordxyh));

	double      sxy[2];
	double      dxy[2];

	S_xy=Sxy;
	D_xy=Dxy;

	if(ptN==1)
	{
		sTransParam->Deltax=D_xy[0].x-S_xy[0].x;
		sTransParam->Deltay=D_xy[0].y-S_xy[0].y;
		sTransParam->Silta =0.0;
		sTransParam->Scale =0.0;
	}
	if(ptN>=2)
	{
		long double         **ldStatusMatrixA;
		long double         *ldXMatrix;		// coeffciences Matrix
		long double     	*ldFMatrix;
		long double			*ldFeMatrix;
		long double			*ldFEMatrix;
		long double			**ldNbbMatrix;
		long double			**ldQxMatrix;	
		long double			**ldPxMatrix;
    
		ldFMatrix   =(long double*)calloc(2,sizeof(long double));
		ldFeMatrix  =(long double*)calloc(4,sizeof(long double));
		ldFEMatrix  =(long double*)calloc(4,sizeof(long double));

		ldXMatrix=(long double*)calloc(4,sizeof(long double));

		ldStatusMatrixA=TwoArrayAlloc(2,4);
		ldNbbMatrix    =TwoArrayAlloc(4,4);
		ldPxMatrix     =TwoArrayAlloc(4,4);
		ldQxMatrix     =TwoArrayAlloc(4,4);

		long double *ldTempVx;		// for  Parameters
		ldTempVx    =(long double*)calloc(4,sizeof(long double));

		for(int j=0;j<2;j++)
			*(ldFMatrix+j)=0.0;

		for(int m=0;m<4;m++)
		{
			*(ldFeMatrix+m)=0.0;
			*(ldFEMatrix+m)=0.0;
			   ldXMatrix[m]=0.0;
				ldTempVx[m]=0.0;
			for(int n=0;n<4;n++)
			{
				ldNbbMatrix[m][n]=0.0;
				ldPxMatrix[m][n]=0.0;
				ldQxMatrix[m][n]=0.0;
			}
		}
	
		for(int i=0;i<ptN;i++)
		{
			dxy[0]=D_xy[i].x;
			dxy[1]=D_xy[i].y;

			sxy[0]=S_xy[i].x;
			sxy[1]=S_xy[i].y;
			

			for(j=0;j<2;j++)
			{
				FormErrEquMatrix2D(j,S_xy[i],ldStatusMatrixA[j]);

				ldFMatrix[j]=dxy[j]-sxy[j];
			}

			m_matrix_adjust.FormNormMatrix(ldStatusMatrixA,2,4,ldNbbMatrix);
			m_matrix_adjust.FormFeMatrix(ldStatusMatrixA,2,4,ldFMatrix,ldFeMatrix);

			for(int m=0;m<4;m++)		
				for(int n=0;n<4;n++)
					ldPxMatrix[m][n]=ldPxMatrix[m][n]+ldNbbMatrix[m][n];

			for(m=0;m<4;m++)		//form the BtPL in normal equation
				ldFEMatrix[m]=ldFEMatrix[m]+ldFeMatrix[m];

			for(m=0;m<4;m++)
				for(int n=0;n<4;n++)
					ldNbbMatrix[m][n]=0;

			for(j=0;j<2;j++)
				ldFMatrix[j]=ldFeMatrix[j]=0;

		}
		if(!m_matrix_adjust.InverseMatrix(4,ldPxMatrix,ldQxMatrix))
		{
			AfxMessageBox("Failure in Normal Equation solving!");
			return;
		}
		m_matrix_adjust.MatrixProduct(ldQxMatrix,4,4,ldFEMatrix,ldTempVx);

		for(m=0;m<4;m++)
		{
			ldXMatrix[m]=ldXMatrix[m]+ldTempVx[m];
			switch(m)
			{
			case 0:
				sTransParam->Deltax=ldXMatrix[m];
				break;
			case 1:
				sTransParam->Deltay=ldXMatrix[m];
				break;
			case 2:
				sTransParam->Silta=ldXMatrix[m];
				break;
			case 3:
				sTransParam->Scale=ldXMatrix[m];
				break;
			default:  
				return;
			}
		}

		free(ldXMatrix);
		free(ldFMatrix);
		free(ldFeMatrix);
		free(ldFEMatrix);

		TwoArrayFree(ldStatusMatrixA);
		TwoArrayFree(ldNbbMatrix);
		TwoArrayFree(ldQxMatrix);
		TwoArrayFree(ldPxMatrix);

	}
	free(S_xy);
	free(D_xy);
}

void CCoordSysTrans::CoordTrans2D(Coordxyh sxy,Coordxyh *dxy,TransParam2D trnsprms)
{
	dxy->x=sxy.x+trnsprms.Deltax+sxy.x*trnsprms.Silta-sxy.y*trnsprms.Scale;
	dxy->y=sxy.y+trnsprms.Deltay+sxy.y*trnsprms.Silta+sxy.x*trnsprms.Scale;
}
