/////////////////////////////////////////////////////////////////////////////
/*--------------------------------------------
תؼ
  2006-09-07ɻ
  -----------------------------------------------*/
/////////////////////////////////////////////////////////////////////////////
// globals
#if !defined(AFX_GeoGLOBAL_H__B661FB27_EEB2_4ED3_AEF8_6918B829D5AC__INCLUDED_)
#define AFX_GeoGLOBAL_H__B661FB27_EEB2_4ED3_AEF8_6918B829D5AC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <math.h>
#include "GeoMath.h"

#define PI 3.1415926535897932384626

//////////////////////////////////////////////////////////////////////////
//άڴ
long double **TwoArrayAlloc(int r,int c);
void TwoArrayFree(long double **x);

//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//Ƕȵ໥ת
int SignOfDouble(double d);				//жһ˫
double Degree2Rad(const double para);	//ת
double Rad2Degree(const double para);	//ת
double Rad2DMS(const double rad);		//ת.ַ
double DMS2Rad(const double dms);		//.ַת
double DMS2Degree(double dms);			//".."ʽĽǶתΪ""ʽ
double Degree2DMS(double degree);		//""ʽĽǶתΪ".."ʽ
double AngleTransfer(double Angle=0,int TypeIn=0,int TypeOut=0);//ĺҪĽǶȵλʵֵλת0:rad; 1:d.mmss ; 2:degree;
//////////////////////////////////////////////////////////////////////////

//ݽǶ͵ȡֵõӦַ
CString GetCsAngleType(int i);

//////////////////////////////////////////////////////////////////////////
//
class CSphere//
{
private:
    double A;		//򳤰뾶
    double B;		//̰뾶
	double Alfa;	
	double E2;
	int m_type;		//0:Զ   1:WGS-84	  2:-54		3-80
public:
	//ĬϵĹ,WGS-84
	CSphere() {A=6378137.0;Alfa=1.0/298.257223563;E2=0.00669437999014132;B=A*(1.0-Alfa);m_type=1;}       
	~CSphere() {}
	//Զ
    CSphere(double s_a,double s_alfa)	{A=s_a;Alfa=s_alfa;E2=2*s_alfa-s_alfa*s_alfa;B=s_a*(1.0-s_alfa);m_type=0;}
	void SetSpherePara(double s_a,double s_alfa) {A=s_a;Alfa=s_alfa;E2=2*s_alfa-s_alfa*s_alfa;B=s_a*(1.0-s_alfa);m_type=0;}
	void GetSpherePara(double *s_a,double *s_alfa=NULL,double *s_e2=NULL,double *s_b=NULL,int *s_type=NULL) 
	{
		if(s_a != NULL)
			*s_a=A;
		if(s_alfa != NULL)
			*s_alfa=Alfa;
		if(s_e2 != NULL)
			*s_e2=E2;
		if(s_b != NULL)
			*s_b=B;
		if(s_type != NULL)
			*s_type=m_type;
	}
	int SetSphereType(int tp) //0:Զ   1:WGS-84	  2:-54		3-80
	{
		if(tp==1)	   {m_type=1;A=6378137.0;Alfa=1.0/298.257223563;E2=0.00669437999014132;B=A*(1.0-Alfa);return m_type;}//WGS-84
		else if(tp==2) {m_type=2;A=6378245.0;Alfa=1.0/298.3;E2=0.00669342162296594;B=A*(1.0-Alfa);return m_type;}//-54
		else if(tp==3) {m_type=3;A=6378140.0;Alfa=1.0/298.257;E2=0.006694384999588;B=A*(1.0-Alfa);return m_type;}//-80
		else
		{
			m_type=0;
			return 0;
		}
	}
	CString GetSpherePara()
	{
		CString str,ret;
		switch(m_type)
		{
		case 0:
			str.Format("Զ");
			break;
		case 1:
			str.Format("WGS84");
			break;
		case 2:
			str.Format("54");
			break;
		case 3:
			str.Format("80");
			break;
		default:
			//no operation
			break;
		}
		ret.Format("%s (a=%.4fm,alfa=1/%f)",str,A,1.0/Alfa);
		return ret;
	}
	CSphere& operator =(CSphere& temp) {A=temp.A;Alfa=temp.Alfa;E2=temp.E2;B=temp.B;m_type=temp.m_type;return *this;}
	BOOL operator !=(CSphere& temp) //жǷ
	{
		if((A!=temp.A)||(Alfa!=temp.Alfa)||(E2!=temp.E2)||(B!=temp.B))
			return TRUE; 
		else 
			return FALSE;
	}
	void Serialize(CArchive &ar)
	{
		if(ar.IsStoring())
		{
			ar<<A<<Alfa<<B<<E2<<m_type;
		}
		else
		{
			ar>>A>>Alfa>>B>>E2>>m_type;
		}
	}
};

struct CoordXYZ
{
	double X;
	double Y;
	double Z;
	CoordXYZ()
	{
		X=Y=Z=0;
	}
};//ռֱṹ

struct CoordBLH
{
	double B;
	double L;
	double H;
	CoordBLH()
	{
		B=L=H=0;
	}

};//ṹ

struct Coordxyh
{
	double x;
	double y;
	double h;
	Coordxyh()
	{
		x=y=h=0;
	}
};//˹ƽֱṹ


//άת
class C3DpointExchange
{
private:
	//ռڵ
	CSphere m_Sphere;

	//ռֱṹ
	CoordXYZ m_XYZ;

	//ṹ
	CoordBLH m_BLH;

	//˹ƽֱṹ
	Coordxyh m_xyh;

	int m_AngleTypeIn;//0:rad; 1:d.mmss ; 2:degree;
	int m_AngleTypeOut;//0:rad; 1:d.mmss ; 2:degree;
public:
	C3DpointExchange()
	{
		m_AngleTypeIn=0;
		m_AngleTypeOut=0;
	}

	//ĺҪĽǶȵλʵֵλת
	void AngleTransfer(int TypeIn=0,int TypeOut=0);

	//ֵ
	void SetSphere(int type=1){m_Sphere.SetSphereType(type);}
	void SetSphere(CSphere sph){m_Sphere=sph;}

	void SetXYZ(double X=0,double Y=0,double Z=0){m_XYZ.X=X;m_XYZ.Y=Y;m_XYZ.Z=Z;}
	void SetXYZ(CoordXYZ pt){m_XYZ=pt;}

	void SetBLH(double B=0,double L=0,double H=0,int AngleType=0){m_BLH.B=B;m_BLH.H=H;m_BLH.L=L;m_AngleTypeIn=AngleType;}
	void SetBLH(CoordBLH pt,int AngleType=0){m_BLH=pt;m_AngleTypeIn=AngleType;}

	void Setxyh(double x=0,double y=0,double h=0){m_xyh.x=x;m_xyh.y=y;m_xyh.h=h;}
	void Setxyh(Coordxyh pt){m_xyh=pt;}

	//ýǶȵλ
	void SetAngleType(int AngleTypeOut=0,int AngleTypeIn=0){m_AngleTypeOut=AngleTypeOut;m_AngleTypeIn=AngleTypeIn;}

	//ȡֵ
	CSphere GetSphere(){ return m_Sphere;}
	void GetSphere(double *s_a,double *s_alfa,double *s_e2,double *s_b,int *s_type){m_Sphere.GetSpherePara(s_a,s_alfa,s_e2,s_b,s_type);}

	CoordXYZ GetXYZ(){ return m_XYZ;};
	void GetXYZ(double *X,double *Y,double *Z){*X=m_XYZ.X;*Y=m_XYZ.Y;*Z=m_XYZ.Z;}

	CoordBLH GetBLH(){ return m_BLH;};

	CString GetBLHcs(CString csSep=","){ CString str; str.Format("B=%.11f%sL=%.11f%sH=%.4fm",m_BLH.B,csSep,m_BLH.L,csSep,m_BLH.H);return str;}

	void GetBLH(double *B,double *L,double *H=NULL){*B=m_BLH.B;*L=m_BLH.L;*H=m_BLH.H;}

	Coordxyh Getxyh(){return m_xyh;};
	void Getxyh(double *x,double *y,double *h){*x=m_xyh.x;*y=m_xyh.y;*h=m_xyh.h;}
	

	////////////////////////////////////////////////////
	//ת-------------------------------

	//˹ͶӰ㺯
	BOOL BLH2xyh(double midL=0//ͶӰmidL
		,double originY=500000//Yӳ
		,double originX=0//ֱԭͨoriginX=0originY=500km
		,double midB=0//ͶӰԭγmidB
		,double mapH=0//ͶӰ߳mapH
		);//BLHxyh
	static BOOL BLH2xyh(CoordBLH s_BLH,Coordxyh *s_xyh,int AngleTypeIn=0,double midL=0,double originY=500000,CSphere *s_Sphere=NULL,int ProType=0,double originX=0,double midB=0,double mapH=0);

	//˹ͶӰ㺯
	BOOL xyh2BLH(double midL=0,double originY=500000,double originX=0,double midB=0,double mapH=0);//xyhBLH
	static BOOL xyh2BLH(Coordxyh s_xyh,CoordBLH *s_BLH,int AngleTypeOut=0,double midL=0,double originY=500000,CSphere *s_Sphere=NULL,int ProType=0,double originX=0,double midB=0,double mapH=0);//xyhBLH
	int xyh2BLHWithL0(double dN, double dE, double dH,int nFlag=0,double dL0dms=0,CoordBLH *blh=NULL);
	
	//˹ͶӰ㺯
	BOOL GaussChangeZone(const double midL1=0,const double midL2=0,double originY=500000.0,double originX=0,double midB=0,double mapH=0);
	static BOOL GaussChangeZone(const double x1,const double y1,const double h1=0,double *x2=NULL,double *y2=NULL,double *h2=NULL,const double midL1=0,const double midL2=0,double originY=500000.0,CSphere *s_Sphere=NULL,int ProType=0,double originX=0,double midB=0,double mapH=0);

	//굽ֱǿռת
	BOOL BLH2XYZ();//BLHXYZ
	static BOOL BLH2XYZ(const double B,const double L,const double H=0,double *X=NULL,double *Y=NULL,double *Z=NULL,int AngleTypeIn=0,CSphere *s_Sphere=NULL);//BLHXYZ

	//ֱǿռ굽ת
	BOOL XYZ2BLH();//XYZBLH
	static BOOL XYZ2BLH(const double X,const double Y,const double Z,double *B,double *L,double *H=NULL,int AngleTypeOut=0,CSphere *s_Sphere=NULL);//XYZBLH
	
	//άƽֱ
	static BOOL Geoxy2SA(double x1,double y1,double x2,double y2,double *S,double *A,int AngleTypeOut=0,int AngleTypeIn=0);//λǺ;
	static BOOL GeoSA2xy(double x1,double y1,double S,double A,double *x2,double *y2,int AngleTypeIn=0,int AngleTypeOut=0);//һͷλԼһ

};

//
class GeodeticSolution
{
private:
	//////////////////////////////////////////////////////////////////////////
	//Ӻ
	static long double DG(long double gm, long double G, long double k2);
	static void K1K2(long double e, long double un, long double *k1, long double *k2);
	static long double K3(long double un, long double F);
	static long double SGN(long double t=0);
	static long double ACOS(long double t=0);
	//////////////////////////////////////////////////////////////////////////
public:
	GeodeticSolution(){};
	~GeodeticSolution(){};

	static BOOL GeoBL2SA(double B1,double L1,double B2,double L2,double *S,double *A,int AngleTypeIn=0,int AngleTypeOut=0,CSphere *s_Sphere=NULL);//
	static BOOL GeoSA2BL(double B1,double L1,double S,double A,double *B2,double *L2,int AngleTypeIn=0,int AngleTypeOut=0,CSphere *s_Sphere=NULL);//ⷴ

};
typedef struct
{
	double	Deltax;//ƽ
	double  Deltay;
	double  Silta; //ת
	double  Scale; //
}TransParam2D;//άתṹ

typedef struct
{
	double	Deltax;//ƽ
	double  Deltay;
	double  Deltaz;
	double  Siltax;//ת
	double  Siltay;
	double  Siltaz;
	double  Scale; //
}TransParam3D;//άתṹ
//άת
class CCoordSysTrans
{
private:
	//////////////////////////////////////////////////////////////////////////
	CMatrix_Adjust m_matrix_adjust;
	long double **TwoArrayAlloc(int r,int c);
	void TwoArrayFree(long double **x);
	//////////////////////////////////////////////////////////////////////////
public:
	CCoordSysTrans(){};
	~CCoordSysTrans(){};

	void FormErrEquMatrix3D(int i,CoordXYZ xyz_s,long double *Matrix);
	void FormErrEquMatrix3D_myself(int i,CoordXYZ xyz_s,long double *Matrix);
	void CacuTransParam3D(int ptN, CoordXYZ *D_XYZ, CoordXYZ *S_XYZ,TransParam3D *sTransParam);
	void CacuTransParam3D_myself(int ptN, CoordXYZ *D_XYZ, CoordXYZ *S_XYZ,TransParam3D *sTransParam);

	void CoordTrans3D(CoordXYZ m_XYZ,CoordXYZ *m_XYZ1,TransParam3D  sTransParam);

	void FormErrEquMatrix2D(int i,Coordxyh xy_s,long double *Matrix);
	void CacuTransParam2D(int ptN,Coordxyh *Dxy, Coordxyh *Sxy,TransParam2D *sTransParam);
	void CoordTrans2D(Coordxyh sxy,Coordxyh *dxy,TransParam2D trnsprms);
};
#endif // !defined(AFX_GeoGLOBAL_H__B661FB27_EEB2_4ED3_AEF8_6918B829D5AC__INCLUDED_)
/////////////////////////////////////////////////////////////////////////////
