// LeftView.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "LeftView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLeftView

IMPLEMENT_DYNCREATE(CLeftView, CListView)

CLeftView::CLeftView()
{
}

CLeftView::~CLeftView()
{
}


BEGIN_MESSAGE_MAP(CLeftView, CListView)
	//{{AFX_MSG_MAP(CLeftView)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnItemchanged)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLeftView drawing

void CLeftView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CLeftView diagnostics

#ifdef _DEBUG
void CLeftView::AssertValid() const
{
	CListView::AssertValid();
}

void CLeftView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLeftView message handlers

void CLeftView::OnInitialUpdate() 
{
	CListView::OnInitialUpdate();
	
	m_ImgSmall.Create(IDB_SMALL, 16, 1, RGB(255, 255, 255)); // ͼб
	m_ImgLarge.Create(IDB_LARGE, 32, 1, RGB(0, 255, 255));

	SetListStyle(LVS_ICON );   // Դͼ귽ʽʾбͼؼеĿ

	pListCtrl=&(GetListCtrl());
	pListCtrl->SetImageList(&m_ImgSmall, LVSIL_SMALL); 	// бͼؼͼб
	pListCtrl->SetImageList(&m_ImgLarge, LVSIL_NORMAL);

	// ΪбͼؼһЩĿ	
	LVITEM item;
	item.mask=LVIF_TEXT|LVIF_IMAGE;
	item.iItem=0;			// 1
	item.iSubItem=0;        // 
	item.pszText="";
	item.iImage=0;  // ùͼбָͼֵ
	pListCtrl->InsertItem(&item);  // ӵ1

	item.iItem=1;           // ׼ӵ2
	item.pszText="ռֱת";
	item.iImage=5;
	pListCtrl->InsertItem(&item);

	item.iItem=2;          // ׼ӵ3
	item.pszText="ͼͶӰ";
	item.iImage=6;
	pListCtrl->InsertItem(&item);

	item.iItem=3;          // ׼ӵ4
	item.pszText="ͼͶӰ";
	item.iImage=4;
	pListCtrl->InsertItem(&item);

	item.iItem=4;          // ׼ӵ5
	item.pszText="";
	item.iImage=7;
	pListCtrl->InsertItem(&item);

	item.iItem=5;          // ׼ӵ6
	item.pszText="ƽ";
	item.iImage=8;
	pListCtrl->InsertItem(&item);

	item.iItem=6;          // 
	item.pszText="ռֱת";
	item.iImage=2;
	pListCtrl->InsertItem(&item);

	item.iItem=7;          // 
	item.pszText="ռֱת";
	item.iImage=12;
	pListCtrl->InsertItem(&item);

	item.iItem=8;          // 
	item.pszText="ƽֱת";
	item.iImage=10;
	pListCtrl->InsertItem(&item);

	item.iItem=9;          // 
	item.pszText="ƽֱת";
	item.iImage=1;
	pListCtrl->InsertItem(&item);
	


	pDoc=GetDocument();//ʼ

}

void CLeftView::SetListStyle(DWORD dwNewStyle)
{
	DWORD  dwOldStyle; 

	HWND  hWndLt=GetListCtrl().GetSafeHwnd();  // бͼؼĴھ
	dwOldStyle=GetWindowLong(hWndLt, GWL_STYLE);  // бͼؼĴڷ
	if((dwOldStyle & LVS_TYPEMASK)!=dwNewStyle)  // жϵǰʾʽǲָķʽ
	{
		dwOldStyle &=~LVS_TYPEMASK;	  // ӾɵĴڷβҪϢ
		dwNewStyle |=dwOldStyle;   // ִ񲻱䣬ıʾʽ
		SetWindowLong(hWndLt, GWL_STYLE, dwNewStyle);  // ıбؼڷ
	}

}

void CLeftView::OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	int  nChoice=pListCtrl->GetNextItem(-1, LVNI_SELECTED);  // ҵǰѡĿ
	if(nChoice!=-1)   // ѡĿ
	{
		pDoc->m_iCurrentOperation=nChoice;
		pDoc->m_csCurrentOperation=pListCtrl->GetItemText(nChoice, 0);     // ñ༭

		pDoc->UpdateAllViews(this);
	}
	

	*pResult = 0;
}

CCoorToolsDoc* CLeftView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCoorToolsDoc)));

	return (CCoorToolsDoc*)m_pDocument;
}

void CLeftView::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	int  nChoice=pListCtrl->GetNextItem(-1, LVNI_SELECTED);  // ҵǰѡĿ
	switch(nChoice)   // ѡĿ
	{
	case 0:
		PostMessage(WM_COMMAND,ID_SET_PARAMETER);
		break;
	case 1:
		PostMessage(WM_COMMAND,ID_BLH_XYZ);
		break;
	case 2:
		PostMessage(WM_COMMAND,ID_MENUITEM_GaussProjection);
		break;
	case 3:
		PostMessage(WM_COMMAND,ID_MENUITEM_GaussChangeZone);
		break;
	case 4:
		PostMessage(WM_COMMAND,ID_MENUITEM_GeoSol);
		break;
	case 5:
		PostMessage(WM_COMMAND,ID_MENUITEM_PlanexySA);
		break;
	case 6:
		PostMessage(WM_COMMAND,ID_MENU_CalPara_3D);
		break;
	case 7:
		PostMessage(WM_COMMAND,ID_MENU_CoordTrans3D);
		break;
	case 8:
		PostMessage(WM_COMMAND,ID_MENU_CalPara2D);
		break;
	case 9:
		PostMessage(WM_COMMAND,ID_MENU_CoordTrans2D);
		break;
	default:
		//no operation
		break;
	}
	
	*pResult = 0;
}
