#if !defined(AFX_LEFTVIEW_H__E6280F11_2DFC_4263_8A17_BF0C0F71998E__INCLUDED_)
#define AFX_LEFTVIEW_H__E6280F11_2DFC_4263_8A17_BF0C0F71998E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LeftView.h : header file
//
#include "Afxcview.h"
#include "CoorToolsDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CLeftView view

class CLeftView : public CListView
{
protected:
	CLeftView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CLeftView)

// Attributes
private:
	CImageList   m_ImgLarge,  m_ImgSmall;
public:

	CListCtrl *pListCtrl;
	CCoorToolsDoc *pDoc;
// Operations
public:
	CCoorToolsDoc* GetDocument();
	void SetListStyle(DWORD dwNewStyle);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLeftView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CLeftView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CLeftView)
	afx_msg void OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LEFTVIEW_H__E6280F11_2DFC_4263_8A17_BF0C0F71998E__INCLUDED_)
