// CoorToolsView.h : interface of the CCoorToolsView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COORTOOLSVIEW_H__176A3B0B_32F0_4258_AD8B_EA592B4DAAB9__INCLUDED_)
#define AFX_COORTOOLSVIEW_H__176A3B0B_32F0_4258_AD8B_EA592B4DAAB9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CoorToolsDoc.h"

class CCoorToolsView : public CScrollView
{
protected: // create from serialization only
	CCoorToolsView();
	DECLARE_DYNCREATE(CCoorToolsView)

// Attributes
public:
	CCoorToolsDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCoorToolsView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCoorToolsView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CCoorToolsDoc *pDoc;

// Generated message map functions
protected:
	//{{AFX_MSG(CCoorToolsView)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in CoorToolsView.cpp
inline CCoorToolsDoc* CCoorToolsView::GetDocument()
   { return (CCoorToolsDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COORTOOLSVIEW_H__176A3B0B_32F0_4258_AD8B_EA592B4DAAB9__INCLUDED_)
