// DlgCalPara2D.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgCalPara2D.h"
#include "GeoGlobal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCalPara2D dialog


CDlgCalPara2D::CDlgCalPara2D(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCalPara2D::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCalPara2D)
	m_dX0 = 0.0;
	m_dY0 = 0.0;
	m_PointName = _T("");
	m_Scale = 0.0;
	m_Silta = 0.0;
	m_Edit_Table = 0.0;
	m_tmp1 = 0.0;
	m_tmp2 = 0.0;
	m_tmp3 = 0.0;
	m_tmp4 = 0.0;
	m_PathOpen = _T("");
	//}}AFX_DATA_INIT
	ptn=0;
	flag=0;
	lRow=1;
}


void CDlgCalPara2D::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCalPara2D)
	DDX_Control(pDX, IDC_EDIT_Table, m_Change);
	DDX_Text(pDX, IDC_EDIT_dX0, m_dX0);
	DDX_Text(pDX, IDC_EDIT_dY0, m_dY0);
	DDX_Text(pDX, IDC_EDIT_Name, m_PointName);
	DDX_Text(pDX, IDC_EDIT_Scale, m_Scale);
	DDX_Text(pDX, IDC_EDIT_Silta, m_Silta);
	DDX_Text(pDX, IDC_EDIT_Table, m_Edit_Table);
	DDX_Text(pDX, IDC_EDIT_Tmp1, m_tmp1);
	DDX_Text(pDX, IDC_EDIT_Tmp2, m_tmp2);
	DDX_Text(pDX, IDC_EDIT_Tmp3, m_tmp3);
	DDX_Text(pDX, IDC_EDIT_Tmp4, m_tmp4);
	DDX_Control(pDX, IDC_MSFLEXGRID1, m_FlexGrid);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCalPara2D, CDialog)
	//{{AFX_MSG_MAP(CDlgCalPara2D)
	ON_BN_CLICKED(IDC_Btn_Add, OnBtnAdd)
	ON_BN_CLICKED(IDC_Btn_Del, OnBtnDel)
	ON_BN_CLICKED(IDC_Btn_Edit, OnBtnEdit)
	ON_WM_KILLFOCUS()
	ON_BN_CLICKED(IDC_Btn_SavePara, OnBtnSavePara)
	ON_EN_KILLFOCUS(IDC_EDIT_Table, OnKillfocusEDITTable)
	ON_BN_CLICKED(IDC_Btn_CalPara, OnBtnCalPara)
	ON_BN_CLICKED(IDC_Btn_ReadFile, OnBtnReadFile)
	ON_BN_CLICKED(IDC_Btn_Import, OnBtnImport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCalPara2D message handlers

void CDlgCalPara2D::OnBtnAdd() 
{
	// TODO: Add your control notification handler code here
	flag=0;
	UpdateData(TRUE);
	ptn++;

	VARIANT vDefault;
	vDefault.vt= VT_ERROR ;
	CString sEntry;
	sEntry = " ";
	m_FlexGrid.AddItem(sEntry,vDefault);

	CString ptn_str,pointname,m_Tmp1,m_Tmp2,m_Tmp3,m_Tmp4,m_Tmp5;
	ptn_str.Format("%d",ptn);
	m_Tmp1.Format("%.4lf",m_tmp1);
	m_Tmp2.Format("%.4lf",m_tmp2);
	m_Tmp3.Format("%.4lf",m_tmp3);
	m_Tmp4.Format("%.4lf",m_tmp4);
	pointname=m_PointName;
	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(0);
	m_FlexGrid.SetText(pointname);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(1);
	m_FlexGrid.SetText(m_Tmp1);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(2);
	m_FlexGrid.SetText(m_Tmp2);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(3);
	m_FlexGrid.SetText(m_Tmp3);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(4);
	m_FlexGrid.SetText(m_Tmp4);	

	m_tmp1=0;
	m_tmp2=0;
	m_tmp3=0;
	m_tmp4=0;
	m_PointName="";
	UpdateData(FALSE);
	
}

void CDlgCalPara2D::OnBtnDel() 
{
	// TODO: Add your control notification handler code here
	flag=0;
	if (lRow<=ptn)

	{
	
		CString strValue;

		for (int i=lRow;i<ptn;i++)
		{
			for (int j=0;j<5;j++)
			{
				strValue=m_FlexGrid.GetTextMatrix(i+1,j);
				m_FlexGrid.SetTextMatrix(i,j,strValue);
					
			}	
		}
		for (int j=0;j<5;j++)
		{
			m_FlexGrid.SetTextMatrix(ptn,j,"");

		}
		m_FlexGrid.RemoveItem(ptn);
		ptn--;

	}
	
}

void CDlgCalPara2D::OnBtnEdit() 
{
	// TODO: Add your control notification handler code here
	flag=1;		
	
}

BOOL CDlgCalPara2D::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_FlexGrid.SetColWidth(-1,1080);
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(0);
	m_FlexGrid.SetText("       ");
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(1);
	m_FlexGrid.SetText("        x");	
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(2);
	m_FlexGrid.SetText("        y");
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(3);
	m_FlexGrid.SetText("        x'");
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(4);
	m_FlexGrid.SetText("        y'");	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgCalPara2D::OnKillFocus(CWnd* pNewWnd) 
{
	CDialog::OnKillFocus(pNewWnd);
	
	// TODO: Add your message handler code here
	
}

BEGIN_EVENTSINK_MAP(CDlgCalPara2D, CDialog)
    //{{AFX_EVENTSINK_MAP(CDlgCalPara2D)
	ON_EVENT(CDlgCalPara2D, IDC_MSFLEXGRID1, -600 /* Click */, OnClickMsflexgrid1, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDlgCalPara2D::OnClickMsflexgrid1() 
{
	// TODO: Add your control notification handler code here
	lRow=m_FlexGrid.GetRowSel();
	long lCol=m_FlexGrid.GetColSel();
	if (lRow>ptn) 
	{
		return;
	}

	if (flag==1)
	{


		if(lRow==0)
			return;
		CRect rect;
		m_FlexGrid.GetWindowRect(rect);
		ScreenToClient(rect);

		CDC *pDC=GetDC();
		int nTwipsPerDotX=1440/pDC->GetDeviceCaps(LOGPIXELSX);
		int nTwipsPerDotY=1440/pDC->GetDeviceCaps(LOGPIXELSY);

		long y=m_FlexGrid.GetRowPos(lRow)/nTwipsPerDotY;
		long x=m_FlexGrid.GetColPos(lCol)/nTwipsPerDotX;

		long width=m_FlexGrid.GetColWidth(lCol)/nTwipsPerDotX+1;
		long height=m_FlexGrid.GetRowHeight(lRow)/nTwipsPerDotY+1;


		CRect rc(x,y,x+width,y+height);
		rc.OffsetRect(rect.left+1,rect.top+1);


		CString strValue=m_FlexGrid.GetTextMatrix(lRow,lCol);
		

		m_Change.ShowWindow(SW_SHOW);
		m_Change.SetWindowText(strValue);
		m_Change.SetFocus();
		m_Change.SetSel(0,-1);
		m_Change.MoveWindow(rc);
	}	
	
}

void CDlgCalPara2D::OnBtnSavePara() 
{
	// TODO: Add your control notification handler code here
	CStdioFile m_ParaFile;
	CString str,m_Path_Open;
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_Path_Open=MyFileDlg.GetPathName();

	if(!m_ParaFile.Open(m_Path_Open,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	m_ParaFile.WriteString("Shift:");
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("dx0: ");
	str.Format("%13.4lf",m_dX0);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("dy0: ");
	str.Format("%13.4lf",m_dY0);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("Rotation:");
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("d: ");
	str.Format("%16.11lf",m_Silta);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("Scale:");
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("d: ");
	str.Format("%16.11lf",m_Scale);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("\n");

	m_ParaFile.WriteString("ʹõĹΪ:");
	m_ParaFile.WriteString("\n");
	for (int i=1;i<=ptn;i++)
	{
		str=m_FlexGrid.GetTextMatrix(i,0);
		m_ParaFile.WriteString(str);
		m_ParaFile.WriteString("     ");

		for (int j=1;j<3;j++)
		{
			str=m_FlexGrid.GetTextMatrix(i,j);
			m_ParaFile.WriteString(str);
			m_ParaFile.WriteString("     ");
		}
		m_ParaFile.WriteString("     ");
		for (j=3;j<5;j++)
		{
			str=m_FlexGrid.GetTextMatrix(i,j);
			m_ParaFile.WriteString(str);
			m_ParaFile.WriteString("     ");
		}
		m_ParaFile.WriteString("\n");
	}
	m_ParaFile.Close();
	ShellExecute(NULL,"Open",m_Path_Open,NULL,NULL,SW_SHOWNORMAL);
	
}

void CDlgCalPara2D::OnKillfocusEDITTable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	UpdateData(false);
	CString m_edit;
	m_edit.Format("%.5lf",m_Edit_Table);
	m_FlexGrid.SetText(m_edit);
	m_Change.ShowWindow(SW_HIDE);
	m_Edit_Table=0.0;
	
}




void CDlgCalPara2D::OnBtnCalPara() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (ptn<1)
	{
		AfxMessageBox("һ㣡");
		return;
	}

	Coordxyh        *s_xy;
	Coordxyh        *d_xy;

	TransParam2D  sTransParam;
	CCoordSysTrans m_coordsystrans;

	s_xy=(Coordxyh*)calloc(ptn,sizeof(Coordxyh));//public points
	d_xy=(Coordxyh*)calloc(ptn,sizeof(Coordxyh));

	long double **m_G;
	long double **m_GP;

	m_G=TwoArrayAlloc(ptn,2);
	m_GP=TwoArrayAlloc(ptn,2);
	
	
	CString str;
	for (int i=1;i<=ptn;i++)
	{
		for (int j=1;j<3;j++)
		{
			str=m_FlexGrid.GetTextMatrix(i,j);
			sscanf(str,"%lf",&m_G[i-1][j-1]);
					
		}
		for (j=3;j<5;j++)
		{
			str=m_FlexGrid.GetTextMatrix(i,j);
			sscanf(str,"%lf",&m_GP[i-1][j-3]);
		}
	}

	for(i=0;i<ptn;i++)
	{
		s_xy[i].x=m_G[i][0];
		s_xy[i].y=m_G[i][1];
		d_xy[i].x=m_GP[i][0];
		d_xy[i].y=m_GP[i][1];
	}
		
	m_coordsystrans.CacuTransParam2D(ptn,d_xy,s_xy,&sTransParam);
	m_dX0=sTransParam.Deltax;
	m_dY0=sTransParam.Deltay;
	m_Silta=sTransParam.Silta;
	m_Scale=sTransParam.Scale;
	
	m_Silta=m_Silta*180*3600/PI;
	
	CString str2;
	
	str2.Format("%.5lf",m_dX0);
	m_dX0=atof(str2);
	str2.Format("%.5lf",m_dY0);
	m_dY0=atof(str2);

	str2.Format("%.9lf",m_Silta);
	m_Silta=atof(str2);
	str2.Format("%.9lf",m_Scale);
	m_Scale=atof(str2);

	UpdateData(FALSE);

	TwoArrayFree(m_G);
	TwoArrayFree(m_GP);			
}

void CDlgCalPara2D::OnBtnReadFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,"txt",NULL,OFN_FILEMUSTEXIST,"ıļ(*.txt)|*.txt|ļ(*.*)|*.*||");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}

void CDlgCalPara2D::OnBtnImport() 
{
	// TODO: Add your control notification handler code here
	flag=0;
	UpdateData(TRUE);

	CStdioFile m_file;
	CString m_stringRead,a;
	CString ptn_str,pointname,m_Tmp1,m_Tmp2,m_Tmp3,m_Tmp4;
	double b,c,d,e;
	if(!m_file.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	while(m_file.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 9 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf %lf %lf",a,&b,&c,&d,&e) < 5) continue;
	
		ptn++;

		VARIANT vDefault;
		vDefault.vt= VT_ERROR ;
		CString sEntry;
		sEntry = " ";
		m_FlexGrid.AddItem(sEntry,vDefault);


		pointname=a;

		m_Tmp1.Format("%.4lf",b);
		m_Tmp2.Format("%.4lf",c);
		m_Tmp3.Format("%.4lf",d);
		m_Tmp4.Format("%.4lf",e);
		
		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(0);
		m_FlexGrid.SetText(pointname);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(1);
		m_FlexGrid.SetText(m_Tmp1);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(2);
		m_FlexGrid.SetText(m_Tmp2);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(3);
		m_FlexGrid.SetText(m_Tmp3);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(4);
		m_FlexGrid.SetText(m_Tmp4);	

	}
	m_file.Close();
	m_PointName="";

	UpdateData(FALSE);

	
}
