// DlgCalPara3D.cpp : implementation file
//

#include "stdafx.h"
#include "CoorTools.h"
#include "DlgCalPara3D.h"
#include "GeoGlobal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgCalPara3D dialog


CDlgCalPara3D::CDlgCalPara3D(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgCalPara3D::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgCalPara3D)
	m_dX0 = 0.0;
	m_dY0 = 0.0;
	m_dZ0 = 0.0;
	m_PointName = _T("");
	m_Scale = 0.0;
	m_Siltax = 0.0;
	m_Siltay = 0.0;
	m_Siltaz = 0.0;
	m_Temp1 = 0.0;
	m_Temp2 = 0.0;
	m_Temp3 = 0.0;
	m_Temp4 = 0.0;
	m_Temp5 = 0.0;
	m_Temp6 = 0.0;
	m_Table_Edit = 0.0;
	m_PathOpen = _T("");
	//}}AFX_DATA_INIT
	ptn=0;
	flag=0;
	lRow=1;
}


void CDlgCalPara3D::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgCalPara3D)
	DDX_Control(pDX, IDC_EDIT_Table, m_Change);
	DDX_Text(pDX, IDC_EDIT_dX0, m_dX0);
	DDX_Text(pDX, IDC_EDIT_dY0, m_dY0);
	DDX_Text(pDX, IDC_EDIT_dZ0, m_dZ0);
	DDX_Text(pDX, IDC_EDIT_PointName, m_PointName);
	DDX_Text(pDX, IDC_EDIT_Scale, m_Scale);
	DDX_Text(pDX, IDC_EDIT_Siltax, m_Siltax);
	DDX_Text(pDX, IDC_EDIT_Siltay, m_Siltay);
	DDX_Text(pDX, IDC_EDIT_Siltaz, m_Siltaz);
	DDX_Text(pDX, IDC_EDIT_Temp1, m_Temp1);
	DDX_Text(pDX, IDC_EDIT_Temp2, m_Temp2);
	DDX_Text(pDX, IDC_EDIT_Temp3, m_Temp3);
	DDX_Text(pDX, IDC_EDIT_Temp4, m_Temp4);
	DDX_Text(pDX, IDC_EDIT_Temp5, m_Temp5);
	DDX_Text(pDX, IDC_EDIT_Temp6, m_Temp6);
	DDX_Text(pDX, IDC_EDIT_Table, m_Table_Edit);
	DDX_Control(pDX, IDC_MSFLEXGRID1, m_FlexGrid);
	DDX_Text(pDX, IDC_EDIT_PathOpen, m_PathOpen);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgCalPara3D, CDialog)
	//{{AFX_MSG_MAP(CDlgCalPara3D)
	ON_BN_CLICKED(IDC_Btn_Add, OnBtnAdd)
	ON_BN_CLICKED(IDC_Btn_Del, OnBtnDel)
	ON_BN_CLICKED(IDC_Btn_Edit, OnBtnEdit)
	ON_EN_KILLFOCUS(IDC_EDIT_Table, OnKillfocusEDITTable)
	ON_BN_CLICKED(IDC_Btn_SavePara, OnBtnSavePara)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_Btn_ReadFile, OnBtnReadFile)
	ON_BN_CLICKED(IDC_Btn_Import, OnBtnImport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgCalPara3D message handlers

void CDlgCalPara3D::OnBtnAdd() 
{
	// TODO: Add your control notification handler code here
	flag=0;
	UpdateData(TRUE);
	ptn++;


	VARIANT vDefault;
	vDefault.vt= VT_ERROR ;
	CString sEntry;
	sEntry = " ";
	m_FlexGrid.AddItem(sEntry,vDefault);

	CString ptn_str,m_csTemp1,m_csTemp2,m_csTemp3,m_csTemp4,m_csTemp5,m_csTemp6,pointname;
	pointname=m_PointName;

	m_csTemp1.Format("%.4lf",m_Temp1);
	m_csTemp2.Format("%.4lf",m_Temp2);
	m_csTemp3.Format("%.4lf",m_Temp3);
	m_csTemp4.Format("%.4lf",m_Temp4);
	m_csTemp5.Format("%.4lf",m_Temp5);
	m_csTemp6.Format("%.4lf",m_Temp6);
	
	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(0);
	m_FlexGrid.SetText(pointname);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(1);
	m_FlexGrid.SetText(m_csTemp1);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(2);
	m_FlexGrid.SetText(m_csTemp2);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(3);
	m_FlexGrid.SetText(m_csTemp3);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(4);
	m_FlexGrid.SetText(m_csTemp4);	

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(5);
	m_FlexGrid.SetText(m_csTemp5);

	m_FlexGrid.SetRow(ptn);
	m_FlexGrid.SetCol(6);
	m_FlexGrid.SetText(m_csTemp6);
	m_Temp1=0;
	m_Temp2=0;
	m_Temp3=0;
	m_Temp4=0;
	m_Temp5=0;
	m_Temp6=0;
	m_PointName="";
	UpdateData(FALSE);
}

void CDlgCalPara3D::OnBtnDel() 
{
	// TODO: Add your control notification handler code here
	flag=0;
//	lRow=m_FlexGrid.GetRowSel();
	if (lRow<=ptn)

	{
	
		CString strValue;

		for (int i=lRow;i<ptn;i++)
		{
			for (int j=0;j<7;j++)
			{
				strValue=m_FlexGrid.GetTextMatrix(i+1,j);
				m_FlexGrid.SetTextMatrix(i,j,strValue);
					
			}	
		}
		for (int j=0;j<7;j++)
		{
			m_FlexGrid.SetTextMatrix(ptn,j,"");

		}
		m_FlexGrid.RemoveItem(ptn);
		ptn--;
	}

}

BEGIN_EVENTSINK_MAP(CDlgCalPara3D, CDialog)
    //{{AFX_EVENTSINK_MAP(CDlgCalPara3D)
	ON_EVENT(CDlgCalPara3D, IDC_MSFLEXGRID1, -600 /* Click */, OnClickMsflexgrid1, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDlgCalPara3D::OnClickMsflexgrid1() 
{
	// TODO: Add your control notification handler code here
	lRow=m_FlexGrid.GetRowSel();
	long lCol=m_FlexGrid.GetColSel();
	if (lRow>ptn)
	{
		return;
	}

	if (flag==1)
	{
		if(lRow==0)
			return;
		CRect rect;
		m_FlexGrid.GetWindowRect(rect);
		ScreenToClient(rect);

		CDC *pDC=GetDC();
		int nTwipsPerDotX=1440/pDC->GetDeviceCaps(LOGPIXELSX);
		int nTwipsPerDotY=1440/pDC->GetDeviceCaps(LOGPIXELSY);

		long y=m_FlexGrid.GetRowPos(lRow)/nTwipsPerDotY;
		long x=m_FlexGrid.GetColPos(lCol)/nTwipsPerDotX;

		long width=m_FlexGrid.GetColWidth(lCol)/nTwipsPerDotX+1;
		long height=m_FlexGrid.GetRowHeight(lRow)/nTwipsPerDotY+1;


		CRect rc(x,y,x+width,y+height);
		rc.OffsetRect(rect.left+1,rect.top+1);


		CString strValue=m_FlexGrid.GetTextMatrix(lRow,lCol);
		
		m_Change.ShowWindow(SW_SHOW);
		m_Change.SetWindowText(strValue);
		m_Change.SetFocus();
		m_Change.SetSel(0,-1);
		m_Change.MoveWindow(rc);
	}	
	
}

void CDlgCalPara3D::OnBtnEdit() 
{
	// TODO: Add your control notification handler code here
	flag=1;		
}

void CDlgCalPara3D::OnKillfocusEDITTable() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	UpdateData(false);
	CString m_edit;
	m_edit.Format("%.5f",m_Table_Edit);
	m_FlexGrid.SetText(m_edit);
	m_Change.ShowWindow(SW_HIDE);
	m_Table_Edit=0.0;
	
}

BOOL CDlgCalPara3D::OnInitDialog() 
{
	
	CDialog::OnInitDialog();
	// TODO: Add extra initialization here
	m_FlexGrid.SetColWidth(-1,1070);
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(0);
	m_FlexGrid.SetText("       ");
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(1);
	m_FlexGrid.SetText("        X");	
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(2);
	m_FlexGrid.SetText("        Y");
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(3);
	m_FlexGrid.SetText("        Z");
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(4);
	m_FlexGrid.SetText("        X'");	
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(5);
	m_FlexGrid.SetText("        Y'");	
	m_FlexGrid.SetRow(0);
	m_FlexGrid.SetCol(6);
	m_FlexGrid.SetText("        Z'");	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgCalPara3D::OnBtnSavePara() 
{
	// TODO: Add your control notification handler code here
	CStdioFile m_ParaFile;
	CString str,m_Path_Open;
	CFileDialog MyFileDlg(FALSE,"txt",NULL,OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,"(*.*)|*.*||k");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_Path_Open=MyFileDlg.GetPathName();

	if(!m_ParaFile.Open(m_Path_Open,CFile::modeCreate | CFile::modeReadWrite|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	m_ParaFile.WriteString("Shift:");
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("dX0: ");
	str.Format("%13.5lf",m_dX0);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("dY0: ");
	str.Format("%13.5lf",m_dY0);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("dZ0: ");
	str.Format("%13.5lf",m_dZ0);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("Rotation:");
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("x: ");
	str.Format("%16.11lf",m_Siltax);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("y: ");
	str.Format("%16.11lf",m_Siltay);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("z: ");
	str.Format("%16.11lf",m_Siltaz);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("Scale:");
	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("d: ");
	str.Format("%16.11lf",m_Scale);
	m_ParaFile.WriteString(str);
	m_ParaFile.WriteString("\n");

	m_ParaFile.WriteString("\n");
	m_ParaFile.WriteString("\n");

	m_ParaFile.WriteString("ʹõĹΪ:\n");
	for (int i=1;i<=ptn;i++)
	{
		str=m_FlexGrid.GetTextMatrix(i,0);
		m_ParaFile.WriteString(str);
		m_ParaFile.WriteString("     ");

		for (int j=1;j<=3;j++)
		{
			str=m_FlexGrid.GetTextMatrix(i,j);
			m_ParaFile.WriteString(str);
			m_ParaFile.WriteString("     ");
		}
		m_ParaFile.WriteString("     ");
		for (j=4;j<=6;j++)
		{
			str=m_FlexGrid.GetTextMatrix(i,j);
			m_ParaFile.WriteString(str);
			m_ParaFile.WriteString("     ");
		}
		m_ParaFile.WriteString("\n");
	}

	m_ParaFile.Close();
	ShellExecute(NULL,"Open",m_Path_Open,NULL,NULL,SW_SHOWNORMAL);
	
}


void CDlgCalPara3D::OnOK() 
{
	// TODO: Add extra validation here
    if(ptn<3)
	{
		AfxMessageBox("꣡");
		return;
	}
	UpdateData(TRUE);

	CCoordSysTrans m_coordsystrans;
	TransParam3D  sTransParam;
	CoordXYZ       *s_XYZ;
	CoordXYZ        *d_XYZ;

	s_XYZ=(CoordXYZ*)calloc(ptn,sizeof(CoordXYZ));// public points
	d_XYZ=(CoordXYZ*)calloc(ptn,sizeof(CoordXYZ));

	//꣬3Dת
	long double **m_Z;
	long double **m_ZP;

	m_Z=::TwoArrayAlloc(ptn,3);
	m_ZP=::TwoArrayAlloc(ptn,3);	
	
	CString str;
	for (int i=1;i<=ptn;i++)
	{
		for (int j=1;j<=3;j++)
		{
			str=m_FlexGrid.GetTextMatrix(i,j);
			sscanf(str,"%lf",&m_Z[i-1][j-1]);
					
		}
		for (j=4;j<=6;j++)
		{
			str=m_FlexGrid.GetTextMatrix(i,j);
			sscanf(str,"%lf",&m_ZP[i-1][j-4]);
		}
	}
	for(i=0;i<ptn;i++)
	{
		s_XYZ[i].X=m_Z[i][0];
		s_XYZ[i].Y=m_Z[i][1];
		s_XYZ[i].Z=m_Z[i][2];
		d_XYZ[i].X=m_ZP[i][0];
		d_XYZ[i].Y=m_ZP[i][1];
		d_XYZ[i].Z=m_ZP[i][2];
	}
		
	//άת
	m_coordsystrans.CacuTransParam3D_myself(ptn,d_XYZ,s_XYZ,&sTransParam);
	m_dX0=sTransParam.Deltax;
	m_dY0=sTransParam.Deltay;
	m_dZ0=sTransParam.Deltaz;

	m_Siltax=sTransParam.Siltax;
	m_Siltay=sTransParam.Siltay;
	m_Siltaz=sTransParam.Siltaz;

	m_Scale=sTransParam.Scale;

	m_Siltax=m_Siltax*180*3600/PI;
	m_Siltay=m_Siltay*180*3600/PI;
	m_Siltaz=m_Siltaz*180*3600/PI;
	
	CString str2;

	str2.Format("%.5lf",m_dX0);
	m_dX0=atof(str2);
	str2.Format("%.5lf",m_dY0);
	m_dY0=atof(str2);
	str2.Format("%.5lf",m_dZ0);
	m_dZ0=atof(str2);

	str2.Format("%.9lf",m_Siltax);
	m_Siltax=atof(str2);
	str2.Format("%.9lf",m_Siltay);
	m_Siltay=atof(str2);
	str2.Format("%.9lf",m_Siltaz);
	m_Siltaz=atof(str2);
	str2.Format("%.9lf",m_Scale);
	m_Scale=atof(str2);

	UpdateData(FALSE);
}

void CDlgCalPara3D::OnButton1() 
{

	CDialog::OnOK();
}

void CDlgCalPara3D::OnBtnReadFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	CFileDialog MyFileDlg(TRUE,"txt",NULL,OFN_FILEMUSTEXIST,"ıļ(*.txt)|*.txt|ļ(*.*)|*.*||");
	if(MyFileDlg.DoModal()!=IDOK)
	{
		return;
	}
	m_PathOpen=MyFileDlg.GetPathName();
	UpdateData(FALSE);
	
}

void CDlgCalPara3D::OnBtnImport() 
{
	// TODO: Add your control notification handler code here
	flag=0;
	UpdateData(TRUE);

	CStdioFile m_file;
	CString m_stringRead,a;
	CString ptn_str,m_csTemp1,m_csTemp2,m_csTemp3,m_csTemp4,m_csTemp5,m_csTemp6,pointname;
	double b,c,d,e,f,g;
	if(!m_file.Open(m_PathOpen,CFile::modeRead|CFile::typeText,NULL))
	{
		AfxMessageBox("ļ!" , MB_ICONSTOP , NULL) ;
		return ;
	}
	while(m_file.ReadString(m_stringRead))
	{
		m_stringRead.TrimLeft();
		m_stringRead.TrimRight();

		if(m_stringRead.GetLength() < 13 ) continue;

		if(sscanf(m_stringRead,"%s %lf %lf %lf %lf %lf %lf",a,&b,&c,&d,&e,&f,&g) < 7) continue;
	
		ptn++;

		VARIANT vDefault;
		vDefault.vt= VT_ERROR ;
		CString sEntry;
		sEntry = " ";
		m_FlexGrid.AddItem(sEntry,vDefault);


		pointname=a;

		m_csTemp1.Format("%.4lf",b);
		m_csTemp2.Format("%.4lf",c);
		m_csTemp3.Format("%.4lf",d);
		m_csTemp4.Format("%.4lf",e);
		m_csTemp5.Format("%.4lf",f);
		m_csTemp6.Format("%.4lf",g);
		
		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(0);
		m_FlexGrid.SetText(pointname);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(1);
		m_FlexGrid.SetText(m_csTemp1);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(2);
		m_FlexGrid.SetText(m_csTemp2);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(3);
		m_FlexGrid.SetText(m_csTemp3);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(4);
		m_FlexGrid.SetText(m_csTemp4);	

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(5);
		m_FlexGrid.SetText(m_csTemp5);

		m_FlexGrid.SetRow(ptn);
		m_FlexGrid.SetCol(6);
		m_FlexGrid.SetText(m_csTemp6);
	}
	m_file.Close();
	m_PointName="";

	UpdateData(FALSE);
	
}
