#if !defined(AFX_DLGGAUSSPROJECTION_H__26F018FA_8F06_48B0_9AB0_34670041520C__INCLUDED_)
#define AFX_DLGGAUSSPROJECTION_H__26F018FA_8F06_48B0_9AB0_34670041520C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgGaussProjection.h : header file
//

#include "GeoGlobal.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgGaussProjection dialog

class CDlgGaussProjection : public CDialog
{
// Construction
public:
	void SetEnableStatus(int iType);
	CDlgGaussProjection(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDlgGaussProjection)
	enum { IDD = IDD_Dlg_GaussProjection };
	double	m_B;
	double	m_L;
	double	m_H;
	double	m_x;
	double	m_y;
	double	m_h;
	CString	m_csParameters;
	double	m_midL;
	double	m_originY;
	CString	m_PathOpen;
	CString	m_PathSave;
	int		m_TransType;
	int		m_ProType;
	//}}AFX_DATA
	CSphere m_Sphere;
	int		m_AngleIn;
	int		m_AngleOut;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgGaussProjection)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgGaussProjection)
	afx_msg void OnBtnParaChange();
	virtual BOOL OnInitDialog();
	afx_msg void OnBtnBLH2xyh();
	afx_msg void OnBtnxyh2BLH();
	afx_msg void OnBtnOpen();
	afx_msg void OnBUTTONSave();
	afx_msg void OnBtnBLH2xyhFile();
	afx_msg void OnBtnxyh2BLHFile();
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGGAUSSPROJECTION_H__26F018FA_8F06_48B0_9AB0_34670041520C__INCLUDED_)
