#if !defined(AFX_DLGGEOSOL_H__0BFB373B_E929_430D_BA7B_12FAB39845A9__INCLUDED_)
#define AFX_DLGGEOSOL_H__0BFB373B_E929_430D_BA7B_12FAB39845A9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgGeoSol.h : header file
//
#include "geoglobal.h"

/////////////////////////////////////////////////////////////////////////////
// CDlgGeoSol dialog

class CDlgGeoSol : public CDialog
{
// Construction
public:
	void SetEnableStatus(int iType);
	CDlgGeoSol(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDlgGeoSol)
	enum { IDD = IDD_Dlg_GeodeticSolution };
	CString	m_csParameters;
	double	m_A;
	double	m_B1;
	double	m_B2;
	double	m_L1;
	double	m_L2;
	double	m_S;
	CString	m_PathOpen;
	CString	m_PathSave;
	int		m_TransType;
	//}}AFX_DATA

	CSphere m_Sphere;
	int		m_AngleIn;
	int		m_AngleOut;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgGeoSol)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDlgGeoSol)
	virtual BOOL OnInitDialog();
	afx_msg void OnBtnParaChange();
	afx_msg void OnBtnBL2SA();
	afx_msg void OnBtnSA2BL();
	afx_msg void OnBtnOpen();
	afx_msg void OnBtnSave();
	afx_msg void OnBtnBL2SAFile();
	afx_msg void OnBtnSA2BLFile();
	afx_msg void OnRadio1();
	afx_msg void OnRadio2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGGEOSOL_H__0BFB373B_E929_430D_BA7B_12FAB39845A9__INCLUDED_)
